import { Injectable, NgModule, Component, ViewChild, Input, Output } from '@angular/core';
import { CustomFieldsModule, ControlErrorsModule, EmptyStateModule, DynamicFormModule, ButtonModule, LoadingStateModule, FieldType, FormField, LocaleModule } from '@seniorsistemas/angular-components';
import { PermissionsModule } from '@seniorsistemas/platform-components';
import { __extends, __spread, __awaiter, __generator, __assign } from 'tslib';
import { HttpParams, HttpClient } from '@angular/common/http';
import { MessageService } from 'primeng/components/common/messageservice';
import { TranslateService, TranslateModule } from '@ngx-translate/core';
import { throwError, Subject, forkJoin, of } from 'rxjs';
import { catchError, takeUntil, filter, map, tap } from 'rxjs/operators';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule, Validators, FormControl, FormGroup, FormBuilder } from '@angular/forms';
import { HotkeyModule, Hotkey, HotkeysService } from 'angular2-hotkeys';
import { CurrencyMaskModule } from 'ng2-currency-mask';
import { CalendarModule } from 'primeng/calendar';
import { ConfirmDialogModule } from 'primeng/confirmdialog';
import { InputTextModule } from 'primeng/inputtext';
import { MessagesModule } from 'primeng/messages';
import { PanelModule } from 'primeng/panel';
import { SharedModule } from 'primeng/shared';
import { SplitButtonModule } from 'primeng/splitbutton';
import { user } from '@seniorsistemas/senior-platform-data';
import { Router, ActivatedRoute } from '@angular/router';
import * as moment_ from 'moment';
import { ConfirmationService } from 'primeng/api';

/**
 * @fileoverview added by tsickle
 * Generated from: shared/services/entity-service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
var  /**
 * @template T
 */
EntityService = /** @class */ (function () {
    function EntityService(http, messageService, entityUrl, actionsUrl, translate) {
        this.http = http;
        this.messageService = messageService;
        this.entityUrl = entityUrl;
        this.actionsUrl = actionsUrl;
        this.translate = translate;
        this.http = http;
        this.messageService = messageService;
        this.entityUrl = entityUrl;
        this.actionsUrl = actionsUrl;
        this.translate = translate;
        this.defaultCatch = this.defaultCatch.bind(this);
    }
    /**
     * @param {?} listParams
     * @return {?}
     */
    EntityService.prototype.getListQueryParams = /**
     * @param {?} listParams
     * @return {?}
     */
    function (listParams) {
        var _a = listParams.page, page = _a === void 0 ? 0 : _a, _b = listParams.size, size = _b === void 0 ? 10 : _b, _c = listParams.sort, sort = _c === void 0 ? [] : _c, _d = listParams.filterQuery, filterQuery = _d === void 0 ? "" : _d, _e = listParams.displayFields, displayFields = _e === void 0 ? [] : _e;
        /** @type {?} */
        var params = new HttpParams();
        params = params.append("size", String(size));
        params = params.append("offset", String(page));
        if (sort && sort.length) {
            params = params.append("orderby", sort
                .map((/**
             * @param {?} s
             * @return {?}
             */
            function (s) {
                /** @type {?} */
                var order = "";
                if (s.order === 1)
                    order = " asc";
                else if (s.order === -1)
                    order = " desc";
                return "" + s.field + order;
            }))
                .join(", "));
        }
        if (filterQuery)
            params = params.append("filter", filterQuery);
        if (displayFields && displayFields.length)
            params = params.append("displayfields", displayFields.join());
        return params;
    };
    /**
     * @private
     * @param {?} listParams
     * @return {?}
     */
    EntityService.prototype.getBodyParams = /**
     * @private
     * @param {?} listParams
     * @return {?}
     */
    function (listParams) {
        var _a = listParams.page, page = _a === void 0 ? 0 : _a, _b = listParams.size, size = _b === void 0 ? 10 : _b, _c = listParams.sort, sort = _c === void 0 ? [] : _c, _d = listParams.filterQuery, filterQuery = _d === void 0 ? "" : _d, _e = listParams.displayFields, displayFields = _e === void 0 ? [] : _e;
        /** @type {?} */
        var bodyParams = {};
        bodyParams.size = size;
        bodyParams.offset = page;
        if (sort && sort.length) {
            bodyParams.orderBy = sort
                .map((/**
             * @param {?} s
             * @return {?}
             */
            function (s) {
                /** @type {?} */
                var order = "";
                if (s.order === 1)
                    order = " asc";
                else if (s.order === -1)
                    order = " desc";
                return "" + s.field + order;
            }))
                .join(", ");
        }
        if (filterQuery)
            bodyParams.filter = filterQuery;
        if (displayFields && displayFields.length)
            bodyParams.displayfields = displayFields.join();
        return bodyParams;
    };
    /**
     * @return {?}
     */
    EntityService.prototype.defaultCatch = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return catchError((/**
         * @param {?} err
         * @return {?}
         */
        function (err) {
            if (err) {
                /** @type {?} */
                var summary = err.status ? String(err.status) : "Error";
                /** @type {?} */
                var detail = (err.error && err.error.message) || err.statusText || err.message || "Error";
                if (err.status === 401) {
                    summary = _this.translate.instant("hcm_clocking_event_foundation.general.error_unauthorized_title");
                    detail = _this.translate.instant("hcm_clocking_event_foundation.general.error_unauthorized_description");
                }
                _this.messageService.add({
                    severity: "error",
                    summary: summary,
                    detail: detail,
                });
            }
            return throwError(err);
        }));
    };
    /**
     * @param {?} listParams
     * @return {?}
     */
    EntityService.prototype.list = /**
     * @param {?} listParams
     * @return {?}
     */
    function (listParams) {
        return this.http.get(this.entityUrl, { params: this.getListQueryParams(listParams) }).pipe(this.defaultCatch());
    };
    /**
     * @param {?} id
     * @return {?}
     */
    EntityService.prototype.get = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        return this.http.get(this.entityUrl + "/" + id).pipe(this.defaultCatch());
    };
    /**
     * @param {?} entity
     * @return {?}
     */
    EntityService.prototype.insert = /**
     * @param {?} entity
     * @return {?}
     */
    function (entity) {
        return this.http.post("" + this.entityUrl, entity).pipe(this.defaultCatch());
    };
    /**
     * @param {?} id
     * @param {?} entity
     * @return {?}
     */
    EntityService.prototype.update = /**
     * @param {?} id
     * @param {?} entity
     * @return {?}
     */
    function (id, entity) {
        return this.http.put(this.entityUrl + "/" + id, entity).pipe(this.defaultCatch());
    };
    /**
     * @param {?} id
     * @return {?}
     */
    EntityService.prototype.delete = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        return this.http.delete(this.entityUrl + "/" + id).pipe(this.defaultCatch());
    };
    /**
     * @param {?} listParams
     * @param {?} action
     * @return {?}
     */
    EntityService.prototype.listCustomFilter = /**
     * @param {?} listParams
     * @param {?} action
     * @return {?}
     */
    function (listParams, action) {
        return this.http.post(this.actionsUrl + "/" + action, this.getBodyParams(listParams)).pipe(this.defaultCatch());
    };
    return EntityService;
}());
if (false) {
    /**
     * @type {?}
     * @protected
     */
    EntityService.prototype.http;
    /**
     * @type {?}
     * @protected
     */
    EntityService.prototype.messageService;
    /**
     * @type {?}
     * @protected
     */
    EntityService.prototype.entityUrl;
    /**
     * @type {?}
     * @protected
     */
    EntityService.prototype.actionsUrl;
    /**
     * @type {?}
     * @protected
     */
    EntityService.prototype.translate;
}
/**
 * @record
 */
function ListParams() { }
if (false) {
    /** @type {?|undefined} */
    ListParams.prototype.page;
    /** @type {?|undefined} */
    ListParams.prototype.size;
    /** @type {?|undefined} */
    ListParams.prototype.sort;
    /** @type {?|undefined} */
    ListParams.prototype.filterQuery;
    /** @type {?|undefined} */
    ListParams.prototype.displayFields;
}
/**
 * @record
 */
function BodyParams() { }
if (false) {
    /** @type {?|undefined} */
    BodyParams.prototype.offset;
    /** @type {?|undefined} */
    BodyParams.prototype.size;
    /** @type {?|undefined} */
    BodyParams.prototype.orderBy;
    /** @type {?|undefined} */
    BodyParams.prototype.filter;
    /** @type {?|undefined} */
    BodyParams.prototype.displayfields;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/bridge/bridge.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BridgeService = /** @class */ (function (_super) {
    __extends(BridgeService, _super);
    function BridgeService(http, messageService, translate) {
        var _this = _super.call(this, http, messageService, "hcm_clocking_event_foundation/general/entities/bridge", "hcm_clocking_event_foundation/general/actions", translate) || this;
        _this.http = http;
        _this.messageService = messageService;
        _this.translate = translate;
        return _this;
    }
    BridgeService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    BridgeService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: MessageService },
        { type: TranslateService }
    ]; };
    return BridgeService;
}(EntityService));
if (false) {
    /**
     * @type {?}
     * @protected
     */
    BridgeService.prototype.http;
    /**
     * @type {?}
     * @protected
     */
    BridgeService.prototype.messageService;
    /**
     * @type {?}
     * @protected
     */
    BridgeService.prototype.translate;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/bridge/bridge.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BridgeModule = /** @class */ (function () {
    function BridgeModule() {
    }
    BridgeModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        PermissionsModule.forChild([
                            {
                                name: "bridge",
                                actions: ["Visualizar", "Incluir", "Editar", "Excluir"],
                                uri: "res://senior.com.br/hcm_clocking_event_foundation/general/entities/bridge",
                            },
                        ]),
                    ],
                    providers: [
                        BridgeService
                    ]
                },] }
    ];
    return BridgeModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/company-clocking-event-indications/company-clocking-event-indications.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CompanyClockingEventIndicationsService = /** @class */ (function (_super) {
    __extends(CompanyClockingEventIndicationsService, _super);
    function CompanyClockingEventIndicationsService(http, messageService, translate) {
        var _this = _super.call(this, http, messageService, "hcm_clocking_event_foundation/general/entities/companyClockingEventIndications", "hcm_clocking_event_foundation/general/actions", translate) || this;
        _this.http = http;
        _this.messageService = messageService;
        _this.translate = translate;
        return _this;
    }
    CompanyClockingEventIndicationsService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    CompanyClockingEventIndicationsService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: MessageService },
        { type: TranslateService }
    ]; };
    return CompanyClockingEventIndicationsService;
}(EntityService));
if (false) {
    /**
     * @type {?}
     * @protected
     */
    CompanyClockingEventIndicationsService.prototype.http;
    /**
     * @type {?}
     * @protected
     */
    CompanyClockingEventIndicationsService.prototype.messageService;
    /**
     * @type {?}
     * @protected
     */
    CompanyClockingEventIndicationsService.prototype.translate;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/company-clocking-event-indications/company-clocking-event-indications.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
var CompanyClockingEventIndicationsModule = /** @class */ (function () {
    function CompanyClockingEventIndicationsModule() {
    }
    CompanyClockingEventIndicationsModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        PermissionsModule.forChild([
                            {
                                name: "companyClockingEventIndications",
                                actions: ["Visualizar", "Incluir", "Editar", "Excluir"],
                                uri: "res://senior.com.br/hcm_clocking_event_foundation/general/entities/companyClockingEventIndications",
                            },
                        ]),
                    ],
                    providers: [
                        CompanyClockingEventIndicationsService,
                    ],
                    declarations: [
                    /*{CA:MODULE_DECLARATIONS:START}*/
                    /*{CA:MODULE_DECLARATIONS:END}*/
                    ],
                    exports: [
                    /*{CA:MODULE_EXPORTS:START}*/
                    /*{CA:MODULE_EXPORTS:END}*/
                    ],
                },] }
    ];
    return CompanyClockingEventIndicationsModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/e-001-pes/e-001-pes.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var E001PesService = /** @class */ (function (_super) {
    __extends(E001PesService, _super);
    function E001PesService(http, messageService, translate) {
        var _this = _super.call(this, http, messageService, "hcm_clocking_event_foundation/general/entities/e001pes", "hcm_clocking_event_foundation/general/actions", translate) || this;
        _this.http = http;
        _this.messageService = messageService;
        _this.translate = translate;
        return _this;
    }
    /**
     * @param {?} listParams
     * @return {?}
     */
    E001PesService.prototype.listExternalE001Pes = /**
     * @param {?} listParams
     * @return {?}
     */
    function (listParams) {
        return this.http
            .get("erpx_fnd/pessoa/entities/e001pes", {
            params: this.getListQueryParams(listParams),
        })
            .pipe(this.defaultCatch());
    };
    E001PesService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    E001PesService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: MessageService },
        { type: TranslateService }
    ]; };
    return E001PesService;
}(EntityService));
if (false) {
    /**
     * @type {?}
     * @protected
     */
    E001PesService.prototype.http;
    /**
     * @type {?}
     * @protected
     */
    E001PesService.prototype.messageService;
    /**
     * @type {?}
     * @protected
     */
    E001PesService.prototype.translate;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/e-001-pes/e-001-pes.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
var E001PesModule = /** @class */ (function () {
    function E001PesModule() {
    }
    E001PesModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        PermissionsModule.forChild([
                            {
                                name: "e001pes",
                                actions: ["Visualizar", "Incluir", "Editar", "Excluir"],
                                uri: "res://senior.com.br/erpx_fnd/pessoa/entities/e001pes",
                            },
                        ]),
                    ],
                    providers: [
                        E001PesService,
                    ],
                    declarations: [
                    /*{CA:MODULE_DECLARATIONS:START}*/
                    /*{CA:MODULE_DECLARATIONS:END}*/
                    ],
                    exports: [
                    /*{CA:MODULE_EXPORTS:START}*/
                    /*{CA:MODULE_EXPORTS:END}*/
                    ],
                },] }
    ];
    return E001PesModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/employee/employee.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var EmployeeService = /** @class */ (function (_super) {
    __extends(EmployeeService, _super);
    function EmployeeService(http, messageService, translate) {
        var _this = _super.call(this, http, messageService, "hcm_contract/employment_contract/entities/employee", "hcm_contract/employment_contract/actions", translate) || this;
        _this.http = http;
        _this.messageService = messageService;
        _this.translate = translate;
        return _this;
    }
    /**
     * @param {?} listParams
     * @return {?}
     */
    EmployeeService.prototype.listExternalEmployee = /**
     * @param {?} listParams
     * @return {?}
     */
    function (listParams) {
        return this.http
            .get("hcm_contract/employment_contract/entities/employee", {
            params: this.getListQueryParams(listParams),
        })
            .pipe(this.defaultCatch());
    };
    EmployeeService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    EmployeeService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: MessageService },
        { type: TranslateService }
    ]; };
    return EmployeeService;
}(EntityService));
if (false) {
    /**
     * @type {?}
     * @protected
     */
    EmployeeService.prototype.http;
    /**
     * @type {?}
     * @protected
     */
    EmployeeService.prototype.messageService;
    /**
     * @type {?}
     * @protected
     */
    EmployeeService.prototype.translate;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/employee/employee.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
var EmployeeModule = /** @class */ (function () {
    function EmployeeModule() {
    }
    EmployeeModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        PermissionsModule.forChild([
                            {
                                name: "employee",
                                actions: ["Visualizar", "Incluir", "Editar", "Excluir"],
                                uri: "res://senior.com.br/hcm_contract/employment_contract/entities/employee",
                            },
                        ]),
                    ],
                    providers: [
                        EmployeeService,
                    ],
                    declarations: [
                    /*{CA:MODULE_DECLARATIONS:START}*/
                    /*{CA:MODULE_DECLARATIONS:END}*/
                    ],
                    exports: [
                    /*{CA:MODULE_EXPORTS:START}*/
                    /*{CA:MODULE_EXPORTS:END}*/
                    ],
                },] }
    ];
    return EmployeeModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/situation-clocking-event/situation-clocking-event.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
var SituationClockingEventService = /** @class */ (function (_super) {
    __extends(SituationClockingEventService, _super);
    /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/
    function SituationClockingEventService(http, messageService, translate) {
        var _this = _super.call(this, http, messageService, "hcm_clocking_event_foundation/general/entities/situationClockingEvent", "hcm_clocking_event_foundation/general/actions", translate) || this;
        _this.http = http;
        _this.messageService = messageService;
        _this.translate = translate;
        return _this;
        /*{CA:CONSTRUCTOR_END:START}*/
        /*{CA:CONSTRUCTOR_END:END}*/
    }
    SituationClockingEventService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    SituationClockingEventService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: MessageService },
        { type: TranslateService }
    ]; };
    return SituationClockingEventService;
}(EntityService));
if (false) {
    /**
     * @type {?}
     * @protected
     */
    SituationClockingEventService.prototype.http;
    /**
     * @type {?}
     * @protected
     */
    SituationClockingEventService.prototype.messageService;
    /**
     * @type {?}
     * @protected
     */
    SituationClockingEventService.prototype.translate;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/situation-clocking-event/situation-clocking-event.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
var SituationClockingEventModule = /** @class */ (function () {
    function SituationClockingEventModule() {
    }
    SituationClockingEventModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        PermissionsModule.forChild([
                            {
                                name: "situationClockingEvent",
                                actions: ["Visualizar", "Incluir", "Editar", "Excluir"],
                                uri: "res://senior.com.br/hcm_clocking_event_foundation/general/entities/situationClockingEvent",
                            },
                        ]),
                    ],
                    providers: [
                        SituationClockingEventService,
                    ],
                    declarations: [
                    /*{CA:MODULE_DECLARATIONS:START}*/
                    /*{CA:MODULE_DECLARATIONS:END}*/
                    ],
                    exports: [
                    /*{CA:MODULE_EXPORTS:START}*/
                    /*{CA:MODULE_EXPORTS:END}*/
                    ],
                },] }
    ];
    return SituationClockingEventModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/situation/situation.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
var SituationService = /** @class */ (function (_super) {
    __extends(SituationService, _super);
    /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/
    function SituationService(http, messageService, translate) {
        var _this = _super.call(this, http, messageService, "hcm_clocking_event_foundation/general/entities/situation", "hcm_clocking_event_foundation/general/actions", translate) || this;
        _this.http = http;
        _this.messageService = messageService;
        _this.translate = translate;
        return _this;
        /*{CA:CONSTRUCTOR_END:START}*/
        /*{CA:CONSTRUCTOR_END:END}*/
    }
    /**
     * @param {?} listParams
     * @return {?}
     */
    SituationService.prototype.listExternalSituation = /**
     * @param {?} listParams
     * @return {?}
     */
    function (listParams) {
        return this.http
            .get("hcm_foundation/general/entities/situation", {
            params: this.getListQueryParams(listParams),
        })
            .pipe(this.defaultCatch());
    };
    SituationService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    SituationService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: MessageService },
        { type: TranslateService }
    ]; };
    return SituationService;
}(EntityService));
if (false) {
    /**
     * @type {?}
     * @protected
     */
    SituationService.prototype.http;
    /**
     * @type {?}
     * @protected
     */
    SituationService.prototype.messageService;
    /**
     * @type {?}
     * @protected
     */
    SituationService.prototype.translate;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/situation/situation.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
var SituationModule = /** @class */ (function () {
    function SituationModule() {
    }
    SituationModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        PermissionsModule.forChild([
                            {
                                name: "situation",
                                actions: ["Visualizar", "Incluir", "Editar", "Excluir"],
                                uri: "res://senior.com.br/hcm_foundation/general/entities/situation",
                            },
                        ]),
                    ],
                    providers: [
                        SituationService,
                    ],
                    declarations: [
                    /*{CA:MODULE_DECLARATIONS:START}*/
                    /*{CA:MODULE_DECLARATIONS:END}*/
                    ],
                    exports: [
                    /*{CA:MODULE_EXPORTS:START}*/
                    /*{CA:MODULE_EXPORTS:END}*/
                    ],
                },] }
    ];
    return SituationModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/time-evaluation-definition/time-evaluation-definition.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
var TimeEvaluationDefinitionService = /** @class */ (function (_super) {
    __extends(TimeEvaluationDefinitionService, _super);
    /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/
    function TimeEvaluationDefinitionService(http, messageService, translate) {
        var _this = _super.call(this, http, messageService, "hcm_clocking_event_foundation/general/entities/timeEvaluationDefinition", "hcm_clocking_event_foundation/general/actions", translate) || this;
        _this.http = http;
        _this.messageService = messageService;
        _this.translate = translate;
        return _this;
        /*{CA:CONSTRUCTOR_END:START}*/
        /*{CA:CONSTRUCTOR_END:END}*/
    }
    TimeEvaluationDefinitionService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    TimeEvaluationDefinitionService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: MessageService },
        { type: TranslateService }
    ]; };
    return TimeEvaluationDefinitionService;
}(EntityService));
if (false) {
    /**
     * @type {?}
     * @protected
     */
    TimeEvaluationDefinitionService.prototype.http;
    /**
     * @type {?}
     * @protected
     */
    TimeEvaluationDefinitionService.prototype.messageService;
    /**
     * @type {?}
     * @protected
     */
    TimeEvaluationDefinitionService.prototype.translate;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/time-evaluation-definition/time-evaluation-definition.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
var TimeEvaluationDefinitionModule = /** @class */ (function () {
    function TimeEvaluationDefinitionModule() {
    }
    TimeEvaluationDefinitionModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        PermissionsModule.forChild([
                            {
                                name: "timeEvaluationDefinition",
                                actions: ["Visualizar", "Incluir", "Editar", "Excluir"],
                                uri: "res://senior.com.br/hcm_clocking_event_foundation/general/entities/timeEvaluationDefinition",
                            },
                        ]),
                    ],
                    providers: [
                        TimeEvaluationDefinitionService,
                    ],
                    declarations: [
                    /*{CA:MODULE_DECLARATIONS:START}*/
                    /*{CA:MODULE_DECLARATIONS:END}*/
                    ],
                    exports: [
                    /*{CA:MODULE_EXPORTS:START}*/
                    /*{CA:MODULE_EXPORTS:END}*/
                    ],
                },] }
    ];
    return TimeEvaluationDefinitionModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/time-evaluation-situation-definition-history/time-evaluation-situation-definition-history.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
var TimeEvaluationSituationDefinitionHistoryService = /** @class */ (function (_super) {
    __extends(TimeEvaluationSituationDefinitionHistoryService, _super);
    /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/
    function TimeEvaluationSituationDefinitionHistoryService(http, messageService, translate) {
        var _this = _super.call(this, http, messageService, "$hcm_clocking_event_foundation/general/entities/timeEvaluationSituationDefinitionHistory", "$hcm_clocking_event_foundation/general/actions", translate) || this;
        _this.http = http;
        _this.messageService = messageService;
        _this.translate = translate;
        return _this;
        /*{CA:CONSTRUCTOR_END:START}*/
        /*{CA:CONSTRUCTOR_END:END}*/
    }
    TimeEvaluationSituationDefinitionHistoryService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    TimeEvaluationSituationDefinitionHistoryService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: MessageService },
        { type: TranslateService }
    ]; };
    return TimeEvaluationSituationDefinitionHistoryService;
}(EntityService));
if (false) {
    /**
     * @type {?}
     * @protected
     */
    TimeEvaluationSituationDefinitionHistoryService.prototype.http;
    /**
     * @type {?}
     * @protected
     */
    TimeEvaluationSituationDefinitionHistoryService.prototype.messageService;
    /**
     * @type {?}
     * @protected
     */
    TimeEvaluationSituationDefinitionHistoryService.prototype.translate;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/time-evaluation-situation-definition-history/time-evaluation-situation-definition-history.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
var TimeEvaluationSituationDefinitionHistoryModule = /** @class */ (function () {
    function TimeEvaluationSituationDefinitionHistoryModule() {
    }
    TimeEvaluationSituationDefinitionHistoryModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        PermissionsModule.forChild([
                            {
                                name: "timeEvaluationSituationDefinitionHistory",
                                actions: ["Visualizar", "Incluir", "Editar", "Excluir"],
                                uri: "res://senior.com.br/hcm_clocking_event_foundation/general/entities/timeEvaluationSituationDefinitionHistory",
                            },
                        ]),
                    ],
                    providers: [
                        TimeEvaluationSituationDefinitionHistoryService,
                    ],
                    declarations: [
                    /*{CA:MODULE_DECLARATIONS:START}*/
                    /*{CA:MODULE_DECLARATIONS:END}*/
                    ],
                    exports: [
                    /*{CA:MODULE_EXPORTS:START}*/
                    /*{CA:MODULE_EXPORTS:END}*/
                    ],
                },] }
    ];
    return TimeEvaluationSituationDefinitionHistoryModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/time-evaluation-situation-definition/time-evaluation-situation-definition.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
var TimeEvaluationSituationDefinitionService = /** @class */ (function (_super) {
    __extends(TimeEvaluationSituationDefinitionService, _super);
    /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/
    function TimeEvaluationSituationDefinitionService(http, messageService, translate) {
        var _this = _super.call(this, http, messageService, "hcm_clocking_event_foundation/general/entities/timeEvaluationSituationDefinition", "hcm_clocking_event_foundation/general/actions", translate) || this;
        _this.http = http;
        _this.messageService = messageService;
        _this.translate = translate;
        return _this;
        /*{CA:CONSTRUCTOR_END:START}*/
        /*{CA:CONSTRUCTOR_END:END}*/
    }
    /**
     * @param {?} timeEvaluationSituationDefinitionId
     * @param {?} id
     * @return {?}
     */
    TimeEvaluationSituationDefinitionService.prototype.getTimeEvaluationSituationDefinitionHistory = /**
     * @param {?} timeEvaluationSituationDefinitionId
     * @param {?} id
     * @return {?}
     */
    function (timeEvaluationSituationDefinitionId, id) {
        return this.http
            .get("hcm_clocking_event_foundation/general/entities/timeEvaluationSituationDefinitionHistory/" + id)
            .pipe(this.defaultCatch());
    };
    /**
     * @param {?} timeEvaluationSituationDefinitionId
     * @param {?} id
     * @param {?} timeEvaluationSituationDefinitionHistoryDto
     * @return {?}
     */
    TimeEvaluationSituationDefinitionService.prototype.updateTimeEvaluationSituationDefinitionHistory = /**
     * @param {?} timeEvaluationSituationDefinitionId
     * @param {?} id
     * @param {?} timeEvaluationSituationDefinitionHistoryDto
     * @return {?}
     */
    function (timeEvaluationSituationDefinitionId, id, timeEvaluationSituationDefinitionHistoryDto) {
        return this.http
            .put("hcm_clocking_event_foundation/general/entities/timeEvaluationSituationDefinitionHistory/" + id, timeEvaluationSituationDefinitionHistoryDto)
            .pipe(this.defaultCatch());
    };
    /**
     * @param {?} timeEvaluationSituationDefinitionId
     * @param {?} listParams
     * @return {?}
     */
    TimeEvaluationSituationDefinitionService.prototype.listTimeEvaluationSituationDefinitionHistory = /**
     * @param {?} timeEvaluationSituationDefinitionId
     * @param {?} listParams
     * @return {?}
     */
    function (timeEvaluationSituationDefinitionId, listParams) {
        return this.http
            .get("hcm_clocking_event_foundation/general/entities/timeEvaluationSituationDefinitionHistory", { params: this.getListQueryParams(listParams) })
            .pipe(this.defaultCatch());
    };
    /**
     * @param {?} timeEvaluationSituationDefinitionId
     * @param {?} timeEvaluationSituationDefinitionHistoryDto
     * @return {?}
     */
    TimeEvaluationSituationDefinitionService.prototype.insertTimeEvaluationSituationDefinitionHistory = /**
     * @param {?} timeEvaluationSituationDefinitionId
     * @param {?} timeEvaluationSituationDefinitionHistoryDto
     * @return {?}
     */
    function (timeEvaluationSituationDefinitionId, timeEvaluationSituationDefinitionHistoryDto) {
        return this.http
            .post("hcm_clocking_event_foundation/general/entities/timeEvaluationSituationDefinitionHistory", timeEvaluationSituationDefinitionHistoryDto)
            .pipe(this.defaultCatch());
    };
    /**
     * @param {?} timeEvaluationSituationDefinitionId
     * @param {?} id
     * @return {?}
     */
    TimeEvaluationSituationDefinitionService.prototype.deleteTimeEvaluationSituationDefinitionHistory = /**
     * @param {?} timeEvaluationSituationDefinitionId
     * @param {?} id
     * @return {?}
     */
    function (timeEvaluationSituationDefinitionId, id) {
        return this.http
            .delete("hcm_clocking_event_foundation/general/entities/timeEvaluationSituationDefinitionHistory/" + id)
            .pipe(this.defaultCatch());
    };
    TimeEvaluationSituationDefinitionService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    TimeEvaluationSituationDefinitionService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: MessageService },
        { type: TranslateService }
    ]; };
    return TimeEvaluationSituationDefinitionService;
}(EntityService));
if (false) {
    /**
     * @type {?}
     * @protected
     */
    TimeEvaluationSituationDefinitionService.prototype.http;
    /**
     * @type {?}
     * @protected
     */
    TimeEvaluationSituationDefinitionService.prototype.messageService;
    /**
     * @type {?}
     * @protected
     */
    TimeEvaluationSituationDefinitionService.prototype.translate;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/time-evaluation-situation-definition/time-evaluation-situation-definition.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
var TimeEvaluationSituationDefinitionModule = /** @class */ (function () {
    function TimeEvaluationSituationDefinitionModule() {
    }
    TimeEvaluationSituationDefinitionModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        PermissionsModule.forChild([
                            {
                                name: "timeEvaluationSituationDefinition",
                                actions: ["Visualizar", "Incluir", "Editar", "Excluir"],
                                uri: "res://senior.com.br/hcm_clocking_event_foundation/general/entities/timeEvaluationSituationDefinition",
                            },
                        ]),
                    ],
                    providers: [
                        TimeEvaluationSituationDefinitionService,
                    ],
                    declarations: [
                    /*{CA:MODULE_DECLARATIONS:START}*/
                    /*{CA:MODULE_DECLARATIONS:END}*/
                    ],
                    exports: [
                    /*{CA:MODULE_EXPORTS:START}*/
                    /*{CA:MODULE_EXPORTS:END}*/
                    ],
                },] }
    ];
    return TimeEvaluationSituationDefinitionModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: core/core-schedules.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CoreSchedulesHistoriesModule = /** @class */ (function () {
    function CoreSchedulesHistoriesModule() {
    }
    CoreSchedulesHistoriesModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        BridgeModule,
                        EmployeeModule,
                        E001PesModule,
                        CompanyClockingEventIndicationsModule,
                        TimeEvaluationDefinitionModule,
                        SituationModule,
                        TimeEvaluationSituationDefinitionModule,
                        TimeEvaluationSituationDefinitionHistoryModule,
                        SituationClockingEventModule
                    ]
                },] }
    ];
    return CoreSchedulesHistoriesModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: shared/focus/focus.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FocusService = /** @class */ (function () {
    function FocusService() {
    }
    /**
     * @return {?}
     */
    FocusService.prototype.focusFirstInvalidInput = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var invalidFields = Array.from(document.getElementsByClassName("ng-invalid"));
        /** @type {?} */
        var firstField = invalidFields.find((/**
         * @param {?} f
         * @return {?}
         */
        function (f) { return f.nodeName !== "FORM"; }));
        if (firstField.nodeName === "P-CALENDAR") {
            /** @type {?} */
            var firstInputId = firstField.getAttribute("ng-reflect-input-id");
            /** @type {?} */
            var firstInvalidInput = document.getElementById(firstInputId);
            if (firstInvalidInput)
                firstInvalidInput.focus();
        }
        else if (firstField.nodeName === "S-LOOKUP") {
            /** @type {?} */
            var nestedInput = this.getNestedInput(firstField.firstElementChild);
            if (nestedInput)
                nestedInput.focus();
        }
        else
            firstField.focus();
    };
    /**
     * @private
     * @param {?} element
     * @return {?}
     */
    FocusService.prototype.getNestedInput = /**
     * @private
     * @param {?} element
     * @return {?}
     */
    function (element) {
        if (element.nodeName === "INPUT") {
            return element;
        }
        return this.getNestedInput(element.firstElementChild);
    };
    return FocusService;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: shared/services/field-customization.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FieldCustomizationService = /** @class */ (function () {
    function FieldCustomizationService(http, messageService) {
        this.http = http;
        this.messageService = messageService;
        this.http = http;
        this.messageService = messageService;
        this.defaultCatch = this.defaultCatch.bind(this);
    }
    /**
     * @param {?} objects
     * @return {?}
     */
    FieldCustomizationService.prototype.commitFiles = /**
     * @param {?} objects
     * @return {?}
     */
    function (objects) {
        return this.http.post("platform/field_customization/actions/commitObject", { objects: objects }).pipe(this.defaultCatch());
    };
    /**
     * @param {?} objects
     * @return {?}
     */
    FieldCustomizationService.prototype.deleteFiles = /**
     * @param {?} objects
     * @return {?}
     */
    function (objects) {
        return this.http.post("platform/field_customization/actions/deleteObjects", objects).pipe(this.defaultCatch());
    };
    /**
     * @param {?} formGroup
     * @return {?}
     */
    FieldCustomizationService.prototype.getFiles = /**
     * @param {?} formGroup
     * @return {?}
     */
    function (formGroup) {
        var _this = this;
        /** @type {?} */
        var fieldCustomization = [];
        if (formGroup.value.custom) {
            fieldCustomization = formGroup.value.custom.fieldCustomization || [];
            delete formGroup.value.custom.fieldCustomization;
        }
        /** @type {?} */
        var filesToCommit = [];
        /** @type {?} */
        var filesToDelete = {};
        fieldCustomization.forEach((/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var domain = _a.domain, service = _a.service, entity = _a.entity, toDelete = _a.toDelete, toInsert = _a.toInsert;
            if (!_this.isEmpty(toInsert)) {
                /** @type {?} */
                var files = Object.keys(toInsert).map((/**
                 * @param {?} key
                 * @return {?}
                 */
                function (key) {
                    /** @type {?} */
                    var version = toInsert[key].version;
                    /** @type {?} */
                    var fileName = toInsert[key].name;
                    /** @type {?} */
                    var objectId = toInsert[key].objectId;
                    return { version: version, fileName: fileName, objectId: objectId };
                }));
                if (!_this.isEmpty(files)) {
                    filesToCommit.push.apply(filesToCommit, __spread(files));
                }
            }
            if (!_this.isEmpty(toDelete)) {
                /** @type {?} */
                var objects_1 = [];
                Object.keys(toDelete).forEach((/**
                 * @param {?} key
                 * @return {?}
                 */
                function (key) {
                    /** @type {?} */
                    var fields = toDelete[key] || [];
                    /** @type {?} */
                    var files = fields.map((/**
                     * @param {?} file
                     * @return {?}
                     */
                    function (file) {
                        return {
                            field: key,
                            objectId: file,
                        };
                    }));
                    objects_1.push.apply(objects_1, __spread(files));
                }));
                filesToDelete = { domain: domain, service: service, entityName: entity, objects: objects_1 };
            }
        }));
        return { filesToCommit: filesToCommit, filesToDelete: filesToDelete };
    };
    /**
     * @param {?} object
     * @return {?}
     */
    FieldCustomizationService.prototype.isEmpty = /**
     * @param {?} object
     * @return {?}
     */
    function (object) {
        if (Array.isArray(object)) {
            return object.length === 0;
        }
        return Object.entries(object).length === 0 && object.constructor === Object;
    };
    /**
     * @return {?}
     */
    FieldCustomizationService.prototype.defaultCatch = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return catchError((/**
         * @param {?} err
         * @return {?}
         */
        function (err) {
            if (err) {
                /** @type {?} */
                var summary = err.status ? String(err.status) : "Error";
                /** @type {?} */
                var detail = (err.error && err.error.message) || err.statusText || err.message || "Error";
                _this.messageService.add({
                    severity: "error",
                    summary: summary,
                    detail: detail,
                });
            }
            return throwError(err);
        }));
    };
    FieldCustomizationService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    FieldCustomizationService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: MessageService }
    ]; };
    return FieldCustomizationService;
}());
if (false) {
    /**
     * @type {?}
     * @protected
     */
    FieldCustomizationService.prototype.http;
    /**
     * @type {?}
     * @protected
     */
    FieldCustomizationService.prototype.messageService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: shared/storage/storage.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var StorageService = /** @class */ (function () {
    function StorageService() {
        this.GET_USER_ID = user.getUserData().then((/**
         * @param {?} user
         * @return {?}
         */
        function (user) { return user.id; }));
    }
    /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    StorageService.prototype.store = /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    function (key, value) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _b = (_a = localStorage).setItem;
                        return [4 /*yield*/, this.GET_USER_ID];
                    case 1:
                        _b.apply(_a, [(_c.sent()) + "_" + key, JSON.stringify(value)]);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} key
     * @return {?}
     */
    StorageService.prototype.get = /**
     * @param {?} key
     * @return {?}
     */
    function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _b = (_a = JSON).parse;
                        _d = (_c = localStorage).getItem;
                        return [4 /*yield*/, this.GET_USER_ID];
                    case 1: return [2 /*return*/, _b.apply(_a, [_d.apply(_c, [(_e.sent()) + "_" + key])]) || {}];
                }
            });
        });
    };
    return StorageService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    StorageService.prototype.GET_USER_ID;
}

/**
 * @fileoverview added by tsickle
 * Generated from: shared/storage/filters-storage.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FiltersStorageService = /** @class */ (function (_super) {
    __extends(FiltersStorageService, _super);
    function FiltersStorageService() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.FILTERS_KEY = "SENIOR_FILTERS";
        return _this;
    }
    /**
     * @param {?} key
     * @param {?} filters
     * @return {?}
     */
    FiltersStorageService.prototype.storeFilters = /**
     * @param {?} key
     * @param {?} filters
     * @return {?}
     */
    function (key, filters) {
        return __awaiter(this, void 0, void 0, function () {
            var store;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _super.prototype.get.call(this, this.FILTERS_KEY)];
                    case 1:
                        store = (_a.sent()) || {};
                        this.removeEmptyValues(filters);
                        store[key] = filters;
                        return [4 /*yield*/, _super.prototype.store.call(this, this.FILTERS_KEY, store)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} key
     * @return {?}
     */
    FiltersStorageService.prototype.getFilters = /**
     * @param {?} key
     * @return {?}
     */
    function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var store;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _super.prototype.get.call(this, this.FILTERS_KEY)];
                    case 1:
                        store = (_a.sent()) || {};
                        return [2 /*return*/, store[key] || {}];
                }
            });
        });
    };
    /**
     * @param {?} key
     * @return {?}
     */
    FiltersStorageService.prototype.removeFilter = /**
     * @param {?} key
     * @return {?}
     */
    function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var store;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _super.prototype.get.call(this, this.FILTERS_KEY)];
                    case 1:
                        store = (_a.sent()) || {};
                        delete store[key];
                        return [4 /*yield*/, _super.prototype.store.call(this, this.FILTERS_KEY, store)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} key
     * @param {?} filters
     * @return {?}
     */
    FiltersStorageService.prototype.clearFilterValue = /**
     * @param {?} key
     * @param {?} filters
     * @return {?}
     */
    function (key, filters) {
        return __awaiter(this, void 0, void 0, function () {
            var store;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _super.prototype.get.call(this, this.FILTERS_KEY)];
                    case 1:
                        store = (_a.sent()) || {};
                        this.removeEmptyValues(filters);
                        store[key] = filters;
                        return [4 /*yield*/, _super.prototype.store.call(this, this.FILTERS_KEY, store)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @private
     * @param {?} filters
     * @return {?}
     */
    FiltersStorageService.prototype.removeEmptyValues = /**
     * @private
     * @param {?} filters
     * @return {?}
     */
    function (filters) {
        Object.keys(filters).forEach((/**
         * @param {?} field
         * @return {?}
         */
        function (field) {
            if (Array.isArray(filters[field]) ? filters[field].length === 0 : !filters[field]) {
                delete filters[field];
            }
        }));
    };
    return FiltersStorageService;
}(StorageService));
if (false) {
    /**
     * @type {?}
     * @private
     */
    FiltersStorageService.prototype.FILTERS_KEY;
}

/**
 * @fileoverview added by tsickle
 * Generated from: shared/storage/paginator-storage.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PaginatorStorageService = /** @class */ (function () {
    function PaginatorStorageService() {
        this.GET_USER_ID = user.getUserData().then((/**
         * @param {?} user
         * @return {?}
         */
        function (user) { return user.id; }));
        this.PAGINATOR_KEY = "SENIOR_PAGINATOR";
    }
    /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    PaginatorStorageService.prototype.store = /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    function (key, value) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _b = (_a = sessionStorage).setItem;
                        return [4 /*yield*/, this.GET_USER_ID];
                    case 1:
                        _b.apply(_a, [(_c.sent()) + "_" + key, JSON.stringify(value)]);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} key
     * @return {?}
     */
    PaginatorStorageService.prototype.get = /**
     * @param {?} key
     * @return {?}
     */
    function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _b = (_a = JSON).parse;
                        _d = (_c = sessionStorage).getItem;
                        return [4 /*yield*/, this.GET_USER_ID];
                    case 1: return [2 /*return*/, _b.apply(_a, [_d.apply(_c, [(_e.sent()) + "_" + key])]) || {}];
                }
            });
        });
    };
    /**
     * @param {?} key
     * @param {?=} listParams
     * @return {?}
     */
    PaginatorStorageService.prototype.storePaginator = /**
     * @param {?} key
     * @param {?=} listParams
     * @return {?}
     */
    function (key, listParams) {
        if (listParams === void 0) { listParams = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var store;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.get(this.PAGINATOR_KEY)];
                    case 1:
                        store = (_a.sent()) || {};
                        store[key] = listParams;
                        return [4 /*yield*/, this.store(this.PAGINATOR_KEY, store)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} key
     * @return {?}
     */
    PaginatorStorageService.prototype.getPaginator = /**
     * @param {?} key
     * @return {?}
     */
    function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var store;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.get(this.PAGINATOR_KEY)];
                    case 1:
                        store = (_a.sent()) || {};
                        return [2 /*return*/, store[key] || {}];
                }
            });
        });
    };
    return PaginatorStorageService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    PaginatorStorageService.prototype.GET_USER_ID;
    /**
     * @type {?}
     * @private
     */
    PaginatorStorageService.prototype.PAGINATOR_KEY;
}

/**
 * @fileoverview added by tsickle
 * Generated from: shared/shared-schedule.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PACKAGE_IMPORTS:END}*/
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
var SharedScheduleModule = /** @class */ (function () {
    function SharedScheduleModule() {
    }
    SharedScheduleModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        /*{CA:MODULE_IMPORTS:START}*/
                        SplitButtonModule,
                        MessagesModule,
                        FormsModule,
                        ReactiveFormsModule,
                        CommonModule,
                        CurrencyMaskModule,
                        TranslateModule,
                        CustomFieldsModule,
                        ControlErrorsModule,
                        EmptyStateModule,
                        DynamicFormModule,
                        PanelModule,
                        InputTextModule,
                        ButtonModule,
                        ConfirmDialogModule,
                        CalendarModule,
                        SharedModule,
                        HotkeyModule,
                        LoadingStateModule,
                    ],
                    providers: [
                        FiltersStorageService,
                        PaginatorStorageService,
                        FocusService,
                        FieldCustomizationService,
                    ],
                    declarations: [
                    /*{CA:MODULE_DECLARATIONS:START}*/
                    /*{CA:MODULE_DECLARATIONS:END}*/
                    ],
                    /*{CA:MODULE_CONFIG:START}*/
                    exports: [
                        SplitButtonModule,
                        MessagesModule,
                        FormsModule,
                        ReactiveFormsModule,
                        CommonModule,
                        CurrencyMaskModule,
                        TranslateModule,
                        CustomFieldsModule,
                        ControlErrorsModule,
                        EmptyStateModule,
                        DynamicFormModule,
                        PanelModule,
                        InputTextModule,
                        ButtonModule,
                        ConfirmDialogModule,
                        CalendarModule,
                        SharedModule,
                        HotkeyModule,
                        LoadingStateModule
                    ]
                    /*{CA:MODULE_CONFIG:END}*/
                },] }
    ];
    return SharedScheduleModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/e-001-pes/e-001-pes.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var moment = moment_;
// @HACK Necessary because of https://github.com/rollup/rollup/issues/670
var  
// @HACK Necessary because of https://github.com/rollup/rollup/issues/670
E001Pes = /** @class */ (function () {
    function E001Pes() {
        this.excluido = false;
    }
    /**
     * @param {?} e001PesDto
     * @param {?=} originEntity
     * @return {?}
     */
    E001Pes.fromDto = /**
     * @param {?} e001PesDto
     * @param {?=} originEntity
     * @return {?}
     */
    function (e001PesDto, originEntity) {
        /** @type {?} */
        var model = __assign({}, e001PesDto);
        model.createdDate = model.createdDate && moment(model.createdDate).toDate();
        model.lastModifiedDate = model.lastModifiedDate && moment(model.lastModifiedDate).toDate();
        /** @type {?} */
        var lookupSeparator = " - ";
        /** @type {?} */
        var displayFields = ["nomPes"];
        model.label = displayFields.map((/**
         * @param {?} field
         * @return {?}
         */
        function (field) { return model[field]; })).join(lookupSeparator);
        return (/** @type {?} */ (model));
    };
    /**
     * @param {?} e001Pes
     * @param {?=} originEntity
     * @return {?}
     */
    E001Pes.toDto = /**
     * @param {?} e001Pes
     * @param {?=} originEntity
     * @return {?}
     */
    function (e001Pes, originEntity) {
        /** @type {?} */
        var dto = __assign({}, e001Pes);
        dto.createdDate = dto.createdDate && moment(dto.createdDate).format();
        dto.lastModifiedDate = dto.lastModifiedDate && moment(dto.lastModifiedDate).format();
        delete dto.label;
        return dto;
    };
    return E001Pes;
}());
if (false) {
    /** @type {?} */
    E001Pes.prototype.id;
    /** @type {?} */
    E001Pes.prototype.nomPes;
    /** @type {?} */
    E001Pes.prototype.excluido;
    /** @type {?} */
    E001Pes.prototype.extIntSts;
    /** @type {?} */
    E001Pes.prototype.extIntMsg;
    /** @type {?} */
    E001Pes.prototype.createdBy;
    /** @type {?} */
    E001Pes.prototype.createdDate;
    /** @type {?} */
    E001Pes.prototype.lastModifiedBy;
    /** @type {?} */
    E001Pes.prototype.lastModifiedDate;
    /** @type {?} */
    E001Pes.prototype.custom;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/employee/employee.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var moment$1 = moment_;
// @HACK Necessary because of https://github.com/rollup/rollup/issues/670
var  
// @HACK Necessary because of https://github.com/rollup/rollup/issues/670
Employee = /** @class */ (function () {
    function Employee() {
        this.deleted = false;
    }
    /**
     * @param {?} employeeDto
     * @param {?=} originEntity
     * @return {?}
     */
    Employee.fromDto = /**
     * @param {?} employeeDto
     * @param {?=} originEntity
     * @return {?}
     */
    function (employeeDto, originEntity) {
        /** @type {?} */
        var model = __assign({}, employeeDto);
        model.hireDate = model.hireDate && moment$1(model.hireDate).toDate();
        model.dismissalDate = model.dismissalDate && moment$1(model.dismissalDate).toDate();
        model.createdDate = model.createdDate && moment$1(model.createdDate).toDate();
        model.lastModifiedDate = model.lastModifiedDate && moment$1(model.lastModifiedDate).toDate();
        /** @type {?} */
        var lookupSeparator = " - ";
        /** @type {?} */
        var displayFields = [
            "id",
            "code",
            "person.nomPes",
            "hireDate",
            "dismissalDate",
            "deleted",
            "extIntSts",
            "extIntMsg",
            "createdBy",
            "createdDate",
            "lastModifiedBy",
            "lastModifiedDate",
        ];
        model.label = displayFields.map((/**
         * @param {?} field
         * @return {?}
         */
        function (field) { return model[field]; })).join(lookupSeparator);
        if (originEntity !== "E001Pes" && model.person)
            model.person = E001Pes.fromDto(model.person, "Employee");
        return (/** @type {?} */ (model));
    };
    /**
     * @param {?} employee
     * @param {?=} originEntity
     * @return {?}
     */
    Employee.toDto = /**
     * @param {?} employee
     * @param {?=} originEntity
     * @return {?}
     */
    function (employee, originEntity) {
        /** @type {?} */
        var dto = __assign({}, employee);
        dto.hireDate = dto.hireDate && moment$1(dto.hireDate).format("YYYY-MM-DD");
        dto.dismissalDate = dto.dismissalDate && moment$1(dto.dismissalDate).format("YYYY-MM-DD");
        dto.createdDate = dto.createdDate && moment$1(dto.createdDate).format();
        dto.lastModifiedDate = dto.lastModifiedDate && moment$1(dto.lastModifiedDate).format();
        delete dto.label;
        if (originEntity !== "E001Pes" && dto.person)
            dto.person = E001Pes.toDto(dto.person, "Employee");
        return dto;
    };
    return Employee;
}());
if (false) {
    /** @type {?} */
    Employee.prototype.id;
    /** @type {?} */
    Employee.prototype.code;
    /** @type {?} */
    Employee.prototype.person;
    /** @type {?} */
    Employee.prototype.employer;
    /** @type {?} */
    Employee.prototype.hireDate;
    /** @type {?} */
    Employee.prototype.dismissalDate;
    /** @type {?} */
    Employee.prototype.deleted;
    /** @type {?} */
    Employee.prototype.extIntSts;
    /** @type {?} */
    Employee.prototype.extIntMsg;
    /** @type {?} */
    Employee.prototype.createdBy;
    /** @type {?} */
    Employee.prototype.createdDate;
    /** @type {?} */
    Employee.prototype.lastModifiedBy;
    /** @type {?} */
    Employee.prototype.lastModifiedDate;
    /** @type {?} */
    Employee.prototype.custom;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/bridge/bridge.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var moment$2 = moment_;
// @HACK Necessary because of https://github.com/rollup/rollup/issues/670
var  
// @HACK Necessary because of https://github.com/rollup/rollup/issues/670
Bridge = /** @class */ (function () {
    function Bridge() {
    }
    /**
     * @param {?} bridgeDto
     * @param {?=} originEntity
     * @return {?}
     */
    Bridge.fromDto = /**
     * @param {?} bridgeDto
     * @param {?=} originEntity
     * @return {?}
     */
    function (bridgeDto, originEntity) {
        /** @type {?} */
        var model = __assign({}, bridgeDto);
        model.originDate = model.originDate && moment$2(model.originDate).toDate();
        model.destinationDate = model.destinationDate && moment$2(model.destinationDate).toDate();
        model.createdDate = model.createdDate && moment$2(model.createdDate).toDate();
        model.lastModifiedDate = model.lastModifiedDate && moment$2(model.lastModifiedDate).toDate();
        /** @type {?} */
        var lookupSeparator = " - ";
        /** @type {?} */
        var displayFields = [
            "id",
            "employee.code",
            "employee.person.nomPes",
            "originDate",
            "destinationDate",
            "createdBy",
            "createdDate",
            "lastModifiedBy",
            "lastModifiedDate",
        ];
        model.label = displayFields.map((/**
         * @param {?} field
         * @return {?}
         */
        function (field) { return model[field]; })).join(lookupSeparator);
        if (originEntity !== "Employee" && model.employee)
            model.employee = Employee.fromDto(model.employee, "Bridge");
        return (/** @type {?} */ (model));
    };
    /**
     * @param {?} bridge
     * @param {?=} originEntity
     * @return {?}
     */
    Bridge.toDto = /**
     * @param {?} bridge
     * @param {?=} originEntity
     * @return {?}
     */
    function (bridge, originEntity) {
        /** @type {?} */
        var dto = __assign({}, bridge);
        dto.originDate = dto.originDate && moment$2(dto.originDate).format("YYYY-MM-DD");
        dto.destinationDate = dto.destinationDate && moment$2(dto.destinationDate).format("YYYY-MM-DD");
        dto.createdDate = dto.createdDate && moment$2(dto.createdDate).format();
        dto.lastModifiedDate = dto.lastModifiedDate && moment$2(dto.lastModifiedDate).format();
        delete dto.label;
        if (originEntity !== "Employee" && dto.employee)
            dto.employee = Employee.toDto(dto.employee, "Bridge");
        return dto;
    };
    return Bridge;
}());
if (false) {
    /** @type {?} */
    Bridge.prototype.id;
    /** @type {?} */
    Bridge.prototype.employee;
    /** @type {?} */
    Bridge.prototype.originDate;
    /** @type {?} */
    Bridge.prototype.destinationDate;
    /** @type {?} */
    Bridge.prototype.createdBy;
    /** @type {?} */
    Bridge.prototype.createdDate;
    /** @type {?} */
    Bridge.prototype.lastModifiedBy;
    /** @type {?} */
    Bridge.prototype.lastModifiedDate;
    /** @type {?} */
    Bridge.prototype.custom;
}

/**
 * @fileoverview added by tsickle
 * Generated from: shared/utils/date-validator.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var moment$3 = moment_;
// @HACK Necessary because of https://github.com/rollup/rollup/issues/670
/**
 * @param {?} startDateTime
 * @param {?} endDateTime
 * @return {?}
 */
function startDateTimeIsBeforeEndDateTimeValidator(startDateTime, endDateTime) {
    if (startDateTime && endDateTime && startDateTime.value && endDateTime.value) {
        /** @type {?} */
        var isInvalid = moment$3(startDateTime.value).seconds(0).isSameOrAfter(moment$3(endDateTime.value).seconds(0)) ? { startDateTimeIsBeforeEndDateTime: { value: [endDateTime.value, startDateTime.value] } } : null;
        if (isInvalid) {
            startDateTime.markAsDirty();
            endDateTime.markAsDirty();
            endDateTime.setErrors(isInvalid);
            startDateTime.setErrors(isInvalid);
            return isInvalid;
        }
        removeErrorFromField(endDateTime, 'startDateTimeIsBeforeEndDateTime');
        removeErrorFromField(startDateTime, 'startDateTimeIsBeforeEndDateTime');
    }
    else if (startDateTime && startDateTime.value && !(endDateTime && endDateTime.value)) {
        removeErrorFromField(startDateTime, 'startDateTimeIsBeforeEndDateTime');
    }
    else if (!(startDateTime && startDateTime.value) && endDateTime && endDateTime.value) {
        removeErrorFromField(endDateTime, 'startDateTimeIsBeforeEndDateTime');
    }
    return null;
}
;
/**
 * @param {?} startDate
 * @param {?} endDate
 * @return {?}
 */
function startDateIsBeforeOrEqualToEndDateValidator(startDate, endDate) {
    if (startDate && endDate && startDate.value && endDate.value) {
        /** @type {?} */
        var forbidden = startDate.value > endDate.value ? { startDateIsBeforeEndDate: { value: endDate.value } } : null;
        if (forbidden) {
            startDate.markAsDirty();
            endDate.markAsDirty();
            startDate.setErrors(forbidden);
            endDate.setErrors(forbidden);
            return forbidden;
        }
        removeErrorFromField(endDate, 'startDateIsBeforeEndDate');
        removeErrorFromField(startDate, 'startDateIsBeforeEndDate');
    }
    else if (startDate && startDate.value && !(endDate && endDate.value)) {
        removeErrorFromField(startDate, 'startDateIsBeforeEndDate');
    }
    else if (!(startDate && startDate.value) && endDate && endDate.value) {
        removeErrorFromField(endDate, 'startDateIsBeforeEndDate');
    }
    return null;
}
/**
 * @param {?} field
 * @param {?} error
 * @return {?}
 */
function removeErrorFromField(field, error) {
    if (field.errors) {
        delete field.errors[error];
    }
    if (JSON.stringify(field.errors) == JSON.stringify({})) {
        field.setErrors(null);
    }
}
/**
 * @param {?} startDate
 * @param {?} endDate
 * @return {?}
 */
function startDateIsBeforeEndDateValidator(startDate, endDate) {
    if (startDate && endDate && startDate.value && endDate.value) {
        /** @type {?} */
        var forbidden = moment$3(startDate.value).isSameOrAfter(endDate.value) ? { startDateIsBeforeEndDate: { value: endDate.value } } : null;
        if (forbidden) {
            startDate.markAsDirty();
            endDate.markAsDirty();
            startDate.setErrors(forbidden);
            endDate.setErrors(forbidden);
            return forbidden;
        }
        removeErrorFromField(endDate, 'startDateIsBeforeEndDate');
        removeErrorFromField(startDate, 'startDateIsBeforeEndDate');
    }
    else if (startDate && startDate.value && !(endDate && endDate.value)) {
        removeErrorFromField(startDate, 'startDateIsBeforeEndDate');
    }
    else if (!(startDate && startDate.value) && endDate && endDate.value) {
        removeErrorFromField(endDate, 'startDateIsBeforeEndDate');
    }
    return null;
}

/**
 * @fileoverview added by tsickle
 * Generated from: shared/utils/utils.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var numberTypes = [FieldType.Integer, FieldType.Double];
/** @type {?} */
var numberPattern = /^\d+\b$/;
/** @type {?} */
var mergeUnique = (/**
 * @param {?} array
 * @param {?} otherArray
 * @return {?}
 */
function (array, otherArray) {
    return array.concat(otherArray.filter((/**
     * @param {?} item
     * @return {?}
     */
    function (item) { return !array.includes(item); })));
});
/** @type {?} */
var isValidFilter = (/**
 * @param {?} type
 * @param {?} value
 * @return {?}
 */
function (type, value) {
    var _a = getTypeInformation(type, value), isValidValue = _a.isValidValue, typeExists = _a.typeExists;
    return !(typeExists && !isValidValue);
});
/** @type {?} */
var getTypeInformation = (/**
 * @param {?} type
 * @param {?} value
 * @return {?}
 */
function (type, value) {
    switch (type) {
        case FieldType.Time:
        case FieldType.Date:
        case FieldType.DateTime:
            return { isValidValue: false, typeExists: true };
        case FieldType.Integer:
        case FieldType.Double:
            return {
                isValidValue: value.match(numberPattern),
                typeExists: numberTypes.includes(type),
            };
        default:
            return {
                isValidValue: value.match(numberPattern),
                typeExists: numberTypes.includes(type),
            };
    }
});
/** @type {?} */
var convertMinutesToTime = (/**
 * @param {?} minutes
 * @param {?=} monthMinute
 * @return {?}
 */
function (minutes, monthMinute) {
    /** @type {?} */
    var time = minutes.replace('.', '');
    /** @type {?} */
    var hour = Math.floor(parseInt(time) / 60);
    /** @type {?} */
    var minute = parseInt(time) % 60;
    /** @type {?} */
    var msg = (hour < 10) ? '0' + hour : hour;
    msg += ':';
    msg += (minute < 10) ? '0' + minute : '' + minute;
    if (monthMinute) {
        msg = putZeroAtHours(msg.toString());
    }
    return msg;
});
/** @type {?} */
var putZeroAtHours = (/**
 * @param {?} msg
 * @return {?}
 */
function (msg) {
    if (msg.length === 4) {
        return '00' + msg;
    }
    else if (msg.length === 5) {
        return '0' + msg;
    }
    else {
        return msg;
    }
});
var ɵ0 = putZeroAtHours;
/** @type {?} */
var convertTimeToMinutes = (/**
 * @param {?} time
 * @return {?}
 */
function (time) {
    if (time) {
        /** @type {?} */
        var array = time.toString().split(':');
        return (array[0] * 60) + parseInt(array[1]);
    }
    return null;
});

/**
 * @fileoverview added by tsickle
 * Generated from: lib/bridge/form/bridge-form.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var moment$4 = moment_;
// @HACK Necessary because of https://github.com/rollup/rollup/issues/670
var BridgeFormComponent = /** @class */ (function () {
    function BridgeFormComponent(companyClockingEventIndicationsService, bridgeService, router, route, messageService, confirmationService, formBuilder, translate, hotkeysService, fieldCustomization, focusService, employeeService) {
        this.companyClockingEventIndicationsService = companyClockingEventIndicationsService;
        this.bridgeService = bridgeService;
        this.router = router;
        this.route = route;
        this.messageService = messageService;
        this.confirmationService = confirmationService;
        this.formBuilder = formBuilder;
        this.translate = translate;
        this.hotkeysService = hotkeysService;
        this.fieldCustomization = fieldCustomization;
        this.focusService = focusService;
        this.employeeService = employeeService;
        this.localeConfig = {};
        this.currencyLocaleOptions = {};
        this.permissions = {};
        this.allPermissions = {};
        this.mainPanelCollapsed = false;
        this.contractTypeOptions = [
            {
                label: this.translate.instant("hcm_clocking_event_foundation.general.contract_type_employee"),
                value: "EMPLOYEE",
            },
            {
                label: this.translate.instant("hcm_clocking_event_foundation.general.contract_type_director"),
                value: "DIRECTOR",
            },
            {
                label: this.translate.instant("hcm_clocking_event_foundation.general.contract_type_trainee"),
                value: "TRAINEE",
            },
            {
                label: this.translate.instant("hcm_clocking_event_foundation.general.contract_type_aprentice"),
                value: "APRENTICE",
            },
            {
                label: this.translate.instant("hcm_clocking_event_foundation.general.contract_type_third_party"),
                value: "THIRD_PARTY",
            },
        ];
        this.employeeLookupDisplayFields = [
            "employer.codEmp",
            "code",
            "person.nomPes",
            "employmentRelationship.contractType",
        ];
        this.employeeAdvancedDisplayFields = ["employer.codEmp", "code", "person.nomPes", "employmentRelationship.contractType"];
        this.employeeLookupSeparator = " - ";
        /*{CA:CLASS_ATTRIBUTES:START}*/
        this.cacheLimitDaysBackwardScheduling = new Map();
        this.onClose = new Subject();
        this.onCloseObservable = this.onClose.asObservable();
        this.ngUnsubscribe = new Subject();
        /*{CA:CONSTRUCTOR_END:START}*/
        /*{CA:CONSTRUCTOR_END:END}*/
    }
    /**
     * @return {?}
     */
    BridgeFormComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        /*{CA:ON_INIT_START:START}*/
        /*{CA:ON_INIT_START:END}*/
        var _this = this;
        this.formGroup = this.getFormGroup();
        if (this.lockedEmployee) {
            this.loadLockedEmployee(this.lockedEmployee);
            this.onSubmitObservable.pipe(takeUntil(this.ngUnsubscribe), filter((/**
             * @param {?} name
             * @return {?}
             */
            function (name) { return name === 'bridge'; }))).subscribe((/**
             * @return {?}
             */
            function () { return _this.onSave(); }));
            if (this.onLockedEmployeeChanges) {
                this.onLockedEmployeeChanges
                    .pipe(takeUntil(this.ngUnsubscribe)).subscribe((/**
                 * @param {?} value
                 * @return {?}
                 */
                function (value) {
                    _this.formGroup = _this.getFormGroup();
                    _this.loadLockedEmployee(value);
                }));
            }
        }
        else {
            this.setHotkeys();
        }
        this.route.params
            .pipe(takeUntil(this.ngUnsubscribe))
            .subscribe((/**
         * @param {?} params
         * @return {?}
         */
        function (params) { return _this.onRouteParamsChange(params); }));
        this.route.data
            .pipe(takeUntil(this.ngUnsubscribe))
            .subscribe((/**
         * @param {?} data
         * @return {?}
         */
        function (data) { return _this.onRouteDataChange(data); }));
        this.employeeSearchFields = this.getEmployeeSearchFields();
        this.employeeSearchGridFields = this.getEmployeeSearchGridFields();
        /*{CA:ON_INIT_END:START}*/
        /*{CA:ON_INIT_END:END}*/
    };
    /**
     * @private
     * @param {?} value
     * @return {?}
     */
    BridgeFormComponent.prototype.loadLockedEmployee = /**
     * @private
     * @param {?} value
     * @return {?}
     */
    function (value) {
        var _this = this;
        if (!this.formGroup.value.employee) {
            this.loading = true;
            this.employeeService.listExternalEmployee({
                filterQuery: "id eq '" + value.employeeId + "'",
                displayFields: this.employeeLookupDisplayFields
            }).subscribe((/**
             * @param {?} dto
             * @return {?}
             */
            function (dto) {
                /** @type {?} */
                var bridge = new Bridge();
                bridge.originDate = moment$4(value.evaluationDate).toDate();
                bridge.employee = Employee.fromDto(dto.contents[0], "Bridge");
                _this.updateSuggestions(bridge);
                _this.formGroup.patchValue(bridge);
                _this.formGroup.controls['employee'].disable();
                _this.loading = false;
            }));
        }
        else {
            this.formGroup.controls['bridge'].setValue(value.evaluationDate);
        }
    };
    /**
     * @return {?}
     */
    BridgeFormComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        /*{CA:ON_VIEW_INIT_START:START}*/
        /*{CA:ON_VIEW_INIT_START:END}*/
        /*{CA:ON_VIEW_INIT_END:START}*/
        /*{CA:ON_VIEW_INIT_END:END}*/
    };
    /**
     * @return {?}
     */
    BridgeFormComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        /*{CA:ON_DESTROY_START:START}*/
        /*{CA:ON_DESTROY_START:END}*/
        this.ngUnsubscribe.unsubscribe();
        this.cacheLimitDaysBackwardScheduling.clear();
        /*{CA:ON_DESTROY_END:START}*/
        /*{CA:ON_DESTROY_END:END}*/
    };
    /**
     * @return {?}
     */
    BridgeFormComponent.prototype.setHotkeys = /**
     * @return {?}
     */
    function () {
        /*{CA:SET_HOTKEYS_START:START}*/
        /*{CA:SET_HOTKEYS_START:END}*/
        var _this = this;
        this.hotkeysService.add(new Hotkey("alt+shift+x", (/**
         * @return {?}
         */
        function () {
            if (_this.permissions.excluir)
                _this.onDelete();
            return false;
        }), ["INPUT", "SELECT", "TEXTAREA"]));
        this.hotkeysService.add(new Hotkey("alt+shift+s", (/**
         * @return {?}
         */
        function () {
            if (_this.isNew() || _this.permissions.editar)
                _this.onSave();
            return false;
        }), ["INPUT", "SELECT", "TEXTAREA"]));
        this.hotkeysService.add(new Hotkey("alt+shift+c", (/**
         * @return {?}
         */
        function () {
            _this.onCancel();
            return false;
        }), ["INPUT", "SELECT", "TEXTAREA"]));
        /*{CA:SET_HOTKEYS_END:START}*/
        /*{CA:SET_HOTKEYS_END:END}*/
    };
    /**
     * @return {?}
     */
    BridgeFormComponent.prototype.isNew = /**
     * @return {?}
     */
    function () {
        return this.routeParams.bridge == "new";
    };
    /**
     * @param {?} params
     * @return {?}
     */
    BridgeFormComponent.prototype.onRouteParamsChange = /**
     * @param {?} params
     * @return {?}
     */
    function (params) {
        /*{CA:ON_ROUTE_PARAMS_CHANGE_START:START}*/
        /*{CA:ON_ROUTE_PARAMS_CHANGE_START:END}*/
        this.routeParams = params;
        /*{CA:ON_ROUTE_PARAMS_CHANGE_END:START}*/
        /*{CA:ON_ROUTE_PARAMS_CHANGE_END:END}*/
    };
    /**
     * @param {?} value
     * @return {?}
     */
    BridgeFormComponent.prototype.updateSuggestions = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        /*{CA:ON_UPDATE_SUGGESTIONS_START:START}*/
        /*{CA:ON_UPDATE_SUGGESTIONS_START:END}*/
        if (value.employee) {
            value.employee.employmentRelationship.contractTypeLabel = this.loadLabelFromEnum(value.employee.employmentRelationship.contractType);
            value.employee.label = this.getSuggestionValue([
                "employer.codEmp",
                "code",
                "person.nomPes",
                "employmentRelationship.contractTypeLabel",
            ], "employee", value, this.employeeLookupSeparator);
            if (value.employee.label.trim() === this.employeeLookupSeparator.trim()) {
                delete value.employee.label;
            }
        }
        /*{CA:ON_UPDATE_SUGGESTIONS_END:START}*/
        /*{CA:ON_UPDATE_SUGGESTIONS_END:END}*/
    };
    /**
     * @param {?} displayFields
     * @param {?} ownerEntity
     * @param {?} value
     * @param {?} separator
     * @return {?}
     */
    BridgeFormComponent.prototype.getSuggestionValue = /**
     * @param {?} displayFields
     * @param {?} ownerEntity
     * @param {?} value
     * @param {?} separator
     * @return {?}
     */
    function (displayFields, ownerEntity, value, separator) {
        var _this = this;
        return displayFields
            .map((/**
         * @param {?} field
         * @return {?}
         */
        function (field) { return _this.getProp(value, ownerEntity + "." + field); }))
            .reduce((/**
         * @param {?} acc
         * @param {?} val
         * @return {?}
         */
        function (acc, val) { return "" + acc + separator + val; }));
    };
    /**
     * @param {?} data
     * @return {?}
     */
    BridgeFormComponent.prototype.onRouteDataChange = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        /*{CA:ON_ROUTE_DATA_CHANGE_START:START}*/
        /*{CA:ON_ROUTE_DATA_CHANGE_START:END}*/
        var _a = data.localeConfig.number, currencySymbol = _a.currencySymbol, thousandsSeparator = _a.thousandsSeparator, decimalSeparator = _a.decimalSeparator;
        this.localeConfig = data.localeConfig;
        this.currencyLocaleOptions = {
            align: "left",
            prefix: currencySymbol,
            thousands: thousandsSeparator,
            decimal: decimalSeparator,
        };
        this.permissions = data.allPermissions.bridge;
        this.allPermissions = data.allPermissions;
        this.validateVisualization();
        if (this.lockedEmployee) {
            return;
        }
        else if (data.entity && data.entity[0]) {
            /** @type {?} */
            var canEdit = this.permissions.editar;
            if (!canEdit)
                this.formGroup.disable();
            /** @type {?} */
            var value = Bridge.fromDto(data.entity[0]);
            this.updateSuggestions(value);
            this.formGroup.patchValue(value);
            /** @type {?} */
            var limitDate = new Date();
            limitDate.setDate(limitDate.getDate() -
                data.entity[1].timeEvaluationDefinition.limitDaysBackwardScheduling);
            this.cacheLimitDaysBackwardScheduling.set(data.entity[1].company.id, limitDate);
        }
        else {
            this.formGroup.patchValue(new Bridge());
        }
        /*{CA:ON_ROUTE_DATA_CHANGE_END:START}*/
        /*{CA:ON_ROUTE_DATA_CHANGE_END:END}*/
    };
    /**
     * @return {?}
     */
    BridgeFormComponent.prototype.onCancel = /**
     * @return {?}
     */
    function () {
        /*{CA:ON_CANCEL_START:START}*/
        /*{CA:ON_CANCEL_START:END}*/
        this.goBack();
        /*{CA:ON_CANCEL_END:START}*/
        /*{CA:ON_CANCEL_END:END}*/
    };
    /**
     * @param {?} filesToDelete
     * @param {?} filesToCommit
     * @return {?}
     */
    BridgeFormComponent.prototype.onSendFile = /**
     * @param {?} filesToDelete
     * @param {?} filesToCommit
     * @return {?}
     */
    function (filesToDelete, filesToCommit) {
        /*{CA:ON_SEND_FILE:START}*/
        /*{CA:ON_SEND_FILE:END}*/
        /*{CA:ON_SEND_FILE:START}*/
        /*{CA:ON_SEND_FILE:END}*/
        /** @type {?} */
        var observables = [];
        if (!this.fieldCustomization.isEmpty(filesToDelete)) {
            observables.push(this.fieldCustomization.deleteFiles(filesToDelete));
        }
        if (!this.fieldCustomization.isEmpty(filesToCommit)) {
            observables.push(this.fieldCustomization.commitFiles(filesToCommit));
        }
        if (!this.fieldCustomization.isEmpty(observables)) {
            return forkJoin(observables);
        }
        else {
            return of({});
        }
    };
    /**
     * @return {?}
     */
    BridgeFormComponent.prototype.onSave = /**
     * @return {?}
     */
    function () {
        /*{CA:ON_SAVE_START:START}*/
        /*{CA:ON_SAVE_START:END}*/
        var _this = this;
        this.loading = true;
        if (!this.formGroup.valid) {
            this.loading = false;
            return this.validateAllFormFields(this.formGroup);
        }
        var _a = this.fieldCustomization.getFiles(this.formGroup), filesToDelete = _a.filesToDelete, filesToCommit = _a.filesToCommit;
        this.getSaveObservable()
            .pipe(takeUntil(this.ngUnsubscribe), catchError((/**
         * @param {?} err
         * @return {?}
         */
        function (err) {
            _this.loading = false;
            return throwError(err);
        })))
            .subscribe((/**
         * @return {?}
         */
        function () {
            /*{CA:ON_SAVE_START_TOP:START}*/
            /*{CA:ON_SAVE_START_TOP:END}*/
            _this.onSendFile(filesToDelete, filesToCommit)
                .pipe(takeUntil(_this.ngUnsubscribe), catchError((/**
             * @param {?} err
             * @return {?}
             */
            function (err) {
                /*{CA:ON_SEND_ERROR_TOP:START}*/
                /*{CA:ON_SEND_ERROR_BOTTOM:END}*/
                _this.loading = false;
                /*{CA:ON_SEND_ERROR_TOP:START}*/
                /*{CA:ON_SEND_ERROR_BOTTOM:END}*/
                return throwError(err);
            })))
                .subscribe((/**
             * @return {?}
             */
            function () {
                _this.addMessage("success", "hcm_clocking_event_foundation.general.saved_message_title", "hcm_clocking_event_foundation.general.saved_message_content");
                if (_this.lockedEmployee) {
                    _this.onClose.next(true);
                    _this.loading = false;
                }
                else {
                    _this.goBack();
                }
                /*{CA:ON_SAVE_START_BOTTOM:START}*/
                /*{CA:ON_SAVE_START_BOTTOM:END}*/
            }));
        }));
        /*{CA:ON_SAVE_END:START}*/
        /*{CA:ON_SAVE_END:END}*/
    };
    /**
     * @return {?}
     */
    BridgeFormComponent.prototype.onDelete = /**
     * @return {?}
     */
    function () {
        /*{CA:ON_DELETE_START:START}*/
        /*{CA:ON_DELETE_START:END}*/
        var _this = this;
        this.confirmationService.confirm({
            message: this.translate.instant("hcm_clocking_event_foundation.general.delete_confirmation_message"),
            header: this.translate.instant("hcm_clocking_event_foundation.general.delete_confirmation_title"),
            accept: (/**
             * @return {?}
             */
            function () {
                return _this.getDeleteObservable().pipe(takeUntil(_this.ngUnsubscribe)).subscribe();
            }),
        });
        /*{CA:ON_DELETE_END:START}*/
        /*{CA:ON_DELETE_END:END}*/
    };
    /**
     * @param {?} obj
     * @param {?} path
     * @return {?}
     */
    BridgeFormComponent.prototype.getProp = /**
     * @param {?} obj
     * @param {?} path
     * @return {?}
     */
    function (obj, path) {
        return path
            .split(".")
            .reduce((/**
         * @param {?} result
         * @param {?} prop
         * @return {?}
         */
        function (result, prop) { return (result[prop] === undefined ? "" : result[prop]); }), obj);
    };
    /**
     * @private
     * @param {?} value
     * @return {?}
     */
    BridgeFormComponent.prototype.loadLabelFromEnum = /**
     * @private
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return this.contractTypeOptions.filter((/**
         * @param {?} r
         * @return {?}
         */
        function (r) { return r.value === value; }))[0].label;
    };
    /**
     * @private
     * @param {?} value
     * @return {?}
     */
    BridgeFormComponent.prototype.loadEnumFromLabel = /**
     * @private
     * @param {?} value
     * @return {?}
     */
    function (value) {
        value = value.toUpperCase().trim();
        if (value && value !== undefined) {
            return this.contractTypeOptions
                .filter((/**
             * @param {?} r
             * @return {?}
             */
            function (r) {
                /** @type {?} */
                var match = r.label.toUpperCase().match(value);
                return match !== null && match.length !== 0;
            }))
                .map((/**
             * @param {?} r
             * @return {?}
             */
            function (r) { return r.value; }));
        }
        return [];
    };
    /**
     * @param {?} value
     * @return {?}
     */
    BridgeFormComponent.prototype.onEmployeeLookupRequest = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        var _this = this;
        /*{CA:ON_EMPLOYEE_LOOKUP_REQUEST_START:START}*/
        /*{CA:ON_EMPLOYEE_LOOKUP_REQUEST_START:END}*/
        /** @type {?} */
        var sort = this.employeeLookupDisplayFields.map((/**
         * @param {?} field
         * @return {?}
         */
        function (field) { return ({ field: field, order: 1 }); }));
        /** @type {?} */
        var filterQuery = this.getEmployeeSearchFields()
            .filter((/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var type = _a.type;
            return isValidFilter(type, value);
        }))
            .map((/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var name = _a.name, type = _a.type;
            if (typeof value == "number")
                return name + " eq " + value;
            else if (type == FieldType.Date)
                return name + " eq '" + moment$4(value).format("YYYY-MM-DD") + "'";
            else if (type == FieldType.Time)
                return name + " eq '" + moment$4(value).format("HH:mm:ss") + "'";
            else if (type == FieldType.DateTime)
                return name + " eq '" + moment$4(value).format() + "'";
            else if (type == FieldType.Enum)
                return _this.loadEnumFromLabel(value)
                    .map((/**
                 * @param {?} enumConstant
                 * @return {?}
                 */
                function (enumConstant) { return name + " eq '" + enumConstant + "'"; }))
                    .join(" or ");
            else if (type == FieldType.String)
                return "containing(upper(" + name + "), upper('" + value.replace(/'/g, "\\'") + "'))";
            else
                return name + " eq '" + value + "'";
        }))
            .filter((/**
         * @param {?} filter
         * @return {?}
         */
        function (filter) { return filter !== ""; }))
            .join(" or ");
        /** @type {?} */
        var displayFields = mergeUnique(this.employeeLookupDisplayFields, this.employeeAdvancedDisplayFields).concat("hireDate", "dismissalDate");
        this.employeeService
            .listExternalEmployee({ sort: sort, filterQuery: filterQuery, displayFields: displayFields })
            .pipe(takeUntil(this.ngUnsubscribe))
            .pipe(map((/**
         * @param {?} list
         * @return {?}
         */
        function (list) { return (__assign({}, list, { contents: list.contents.map((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return (__assign({}, item, { label: _this.employeeLookupDisplayFields
                    .map((/**
                 * @param {?} field
                 * @return {?}
                 */
                function (field) {
                    if (field.indexOf(".") > 0)
                        item[field] = _this.getProp(item, field);
                    if (field === "employmentRelationship.contractType") {
                        item[field] = _this.loadLabelFromEnum(item[field]);
                    }
                    return item[field];
                }))
                    .join(_this.employeeLookupSeparator) })); })) })); })))
            .subscribe((/**
         * @param {?} list
         * @return {?}
         */
        function (list) {
            _this.employeeLookupSuggestions = list.contents;
        }));
        /*{CA:ON_EMPLOYEE_LOOKUP_REQUEST_END:START}*/
        /*{CA:ON_EMPLOYEE_LOOKUP_REQUEST_END:END}*/
    };
    /**
     * @param {?} event
     * @return {?}
     */
    BridgeFormComponent.prototype.onEmployeeSearchRequest = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        /*{CA:ON_EMPLOYEE_SEARCH_REQUEST_START:START}*/
        /*{CA:ON_EMPLOYEE_SEARCH_REQUEST_START:END}*/
        var _this = this;
        /*{CA:ON_EMPLOYEE_SEARCH_REQUEST_START:START}*/
        /*{CA:ON_EMPLOYEE_SEARCH_REQUEST_START:END}*/
        var first = event.first, rows = event.rows, multiSortMeta = event.multiSortMeta, filterData = event.filterData;
        /** @type {?} */
        var page = first / rows;
        /** @type {?} */
        var sort = multiSortMeta;
        /** @type {?} */
        var filterQuery = this.getEmployeeSearchFields()
            .filter((/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var name = _a.name;
            return filterData[name] != undefined && filterData[name] != "";
        }))
            .map((/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var name = _a.name, type = _a.type;
            /** @type {?} */
            var value = filterData[name];
            if (typeof value == "number")
                return name + " eq " + value;
            else if (type == FieldType.Date)
                return name + " eq '" + moment$4(value).format("YYYY-MM-DD") + "'";
            else if (type == FieldType.Time)
                return name + " eq '" + moment$4(value).format("HH:mm:ss") + "'";
            else if (type == FieldType.DateTime)
                return name + " eq '" + moment$4(value).format() + "'";
            else if (type == FieldType.Enum)
                return name + " eq '" + value + "'";
            else if (type == FieldType.String)
                return "containing(upper(" + name + "), upper('" + value.replace(/'/g, "\\'") + "'))";
            else
                return name + " eq '" + value + "'";
        }))
            .join(" and ");
        /** @type {?} */
        var displayFields = mergeUnique(this.employeeLookupDisplayFields, this.employeeAdvancedDisplayFields).concat("hireDate", "dismissalDate");
        this.employeeService
            .listExternalEmployee({ page: page, sort: sort, filterQuery: filterQuery, displayFields: displayFields })
            .pipe(takeUntil(this.ngUnsubscribe))
            .pipe(map((/**
         * @param {?} list
         * @return {?}
         */
        function (list) { return (__assign({}, list, { contents: list.contents.map((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return (__assign({}, item, { label: _this.employeeLookupDisplayFields
                    .map((/**
                 * @param {?} field
                 * @return {?}
                 */
                function (field) {
                    if (field.indexOf(".") > 0)
                        item[field] = _this.getProp(item, field); // NOSONAR
                    if (field === "employmentRelationship.contractType") { // NOSONAR
                        item[field] = _this.loadLabelFromEnum(item[field]); // NOSONAR
                    } // NOSONAR
                    return item[field]; // NOSONAR
                })) // NOSONAR
                    .join(_this.employeeLookupSeparator) })); })) })); })) // NOSONAR
        ) // NOSONAR
            .subscribe((/**
         * @param {?} list
         * @return {?}
         */
        function (list) {
            _this.employeeSearchGridData = list.contents; // NOSONAR
            _this.employeeSearchTotalRecords = list.totalElements; // NOSONAR
        })); // NOSONAR
        /*{CA:ON_EMPLOYEE_SEARCH_REQUEST_END:START}*/
        /*{CA:ON_EMPLOYEE_SEARCH_REQUEST_END:END}*/
    };
    /**
     * @private
     * @return {?}
     */
    BridgeFormComponent.prototype.getFormGroup = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var formGroup = this.formBuilder.group({
            id: [{ value: undefined, disabled: true }, Validators.compose([])],
            employee: [
                { value: undefined, disabled: false },
                Validators.compose([Validators.required]),
            ],
            originDate: [
                { value: undefined, disabled: false },
                Validators.compose([Validators.required]),
            ],
            destinationDate: [
                { value: undefined, disabled: false },
                Validators.compose([Validators.required]),
            ],
            createdBy: [{ value: undefined, disabled: true }, Validators.compose([])],
            createdDate: [{ value: undefined, disabled: true }, Validators.compose([])],
            lastModifiedBy: [{ value: undefined, disabled: true }, Validators.compose([])],
            lastModifiedDate: [{ value: undefined, disabled: true }, Validators.compose([])],
            custom: [],
        }, {
            validators: [
                this.validLimitDaysBackwardScheduling(),
                this.startDateIsBeforeEndDate(),
            ],
        });
        formGroup.controls.employee.valueChanges.subscribe((/**
         * @param {?} employee
         * @return {?}
         */
        function (employee) {
            if (employee) {
                /** @type {?} */
                var limitDaysBackwardScheduling = _this.cacheLimitDaysBackwardScheduling.get(employee.employer.id);
                if (limitDaysBackwardScheduling === undefined) {
                    _this.companyClockingEventIndicationsService
                        .get(employee.employer.id)
                        .pipe(catchError((/**
                     * @param {?} error
                     * @return {?}
                     */
                    function (error) {
                        formGroup.controls.employee.setErrors({
                            hasNotCompanyClockingEventIndications: { value: error },
                        });
                        return throwError(error);
                    })))
                        .subscribe((/**
                     * @param {?} companyClockingEventIndications
                     * @return {?}
                     */
                    function (companyClockingEventIndications) {
                        /** @type {?} */
                        var limitDate = new Date();
                        limitDate.setDate(limitDate.getDate() -
                            companyClockingEventIndications.timeEvaluationDefinition
                                .limitDaysBackwardScheduling);
                        _this.cacheLimitDaysBackwardScheduling.set(companyClockingEventIndications.id, limitDate);
                    }));
                }
            }
        }));
        return formGroup;
    };
    /**
     * @private
     * @return {?}
     */
    BridgeFormComponent.prototype.getEmployeeSearchFields = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var searchFields = [
            new FormField({
                name: "employer.codEmp",
                label: this.translate.instant("hcm_clocking_event_foundation.general.employee_employer_cod_emp"),
                type: FieldType.Integer,
            }),
            new FormField({
                name: "code",
                label: this.translate.instant("hcm_clocking_event_foundation.general.employee_code"),
                type: FieldType.Integer,
            }),
            new FormField({
                name: "person.nomPes",
                label: this.translate.instant("hcm_clocking_event_foundation.general.employee_person_nom_pes"),
                type: FieldType.String,
            }),
            new FormField({
                name: "employmentRelationship.contractType",
                label: this.translate.instant("hcm_clocking_event_foundation.general.employee_employment_relationship_contract_type"),
                type: FieldType.Enum,
                options: this.contractTypeOptions,
            }),
        ];
        /*{CA:GET_EMPLOYEE_SEARCH_FIELDS:START}*/
        /*{CA:GET_EMPLOYEE_SEARCH_FIELDS:END}*/
        return searchFields;
    };
    /**
     * @private
     * @return {?}
     */
    BridgeFormComponent.prototype.getEmployeeSearchGridFields = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var searchGridFields = [
            new FormField({
                name: "employer.codEmp",
                label: this.translate.instant("hcm_clocking_event_foundation.general.employee_employer_cod_emp"),
                type: FieldType.Integer,
            }),
            new FormField({
                name: "code",
                label: this.translate.instant("hcm_clocking_event_foundation.general.employee_code"),
                type: FieldType.Integer,
            }),
            new FormField({
                name: "person.nomPes",
                label: this.translate.instant("hcm_clocking_event_foundation.general.employee_person_nom_pes"),
                type: FieldType.String,
            }),
            new FormField({
                name: "employmentRelationship.contractType",
                label: this.translate.instant("hcm_clocking_event_foundation.general.employee_employment_relationship_contract_type"),
                type: FieldType.Enum,
                options: this.contractTypeOptions
            }),
        ];
        /*{CA:GET_EMPLOYEE_SEARCH_GRID_FIELDS:START}*/
        /*{CA:GET_EMPLOYEE_SEARCH_GRID_FIELDS:END}*/
        return searchGridFields;
    };
    /**
     * @private
     * @return {?}
     */
    BridgeFormComponent.prototype.goBack = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var previousRoute = "../";
        this.router.navigate([previousRoute], { relativeTo: this.route.parent });
    };
    /**
     * @private
     * @param {?} formGroup
     * @return {?}
     */
    BridgeFormComponent.prototype.validateAllFormFields = /**
     * @private
     * @param {?} formGroup
     * @return {?}
     */
    function (formGroup) {
        var _this = this;
        Object.keys(formGroup.controls).forEach((/**
         * @param {?} field
         * @return {?}
         */
        function (field) {
            /** @type {?} */
            var control = formGroup.get(field);
            if (control instanceof FormControl)
                control.markAsDirty({ onlySelf: true });
            else if (control instanceof FormGroup)
                _this.validateAllFormFields(control);
        }));
        this.focusService.focusFirstInvalidInput();
        /*{CA:FOCUS_FIRST_INVALID:START}*/
        /*{CA:FOCUS_FIRST_INVALID:END}*/
    };
    /**
     * @private
     * @return {?}
     */
    BridgeFormComponent.prototype.getSaveObservable = /**
     * @private
     * @return {?}
     */
    function () {
        this.formGroup.controls['employee'].enable();
        var value = this.formGroup.value;
        /** @type {?} */
        var bridgeDto = Bridge.toDto(value);
        /** @type {?} */
        var observable;
        if (this.isNew() || (this.lockedEmployee && !value.id)) {
            observable = this.bridgeService.insert(bridgeDto);
        }
        else {
            /** @type {?} */
            var id = this.routeParams.bridge;
            observable = this.bridgeService.update(id, bridgeDto);
        }
        return observable;
    };
    /**
     * @private
     * @return {?}
     */
    BridgeFormComponent.prototype.getDeleteObservable = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        return this.bridgeService.delete(this.routeParams.bridge).pipe(tap((/**
         * @return {?}
         */
        function () {
            _this.addMessage(// NOSONAR
            "success", // NOSONAR
            "hcm_clocking_event_foundation.general.deleted_message_title", // NOSONAR
            "hcm_clocking_event_foundation.general.deleted_message_content" // NOSONAR
            ); // NOSONAR
            _this.goBack(); // NOSONAR
        })) // NOSONAR
        ); // NOSONAR
    }; // NOSONAR
    // NOSONAR
    /**
     * @private
     * @return {?}
     */
    BridgeFormComponent.prototype.validateVisualization = 
    // NOSONAR
    /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        /*{CA:VALIDATE_VISUALIZATION_START:START}*/
        /*{CA:VALIDATE_VISUALIZATION_START:END}*/
        /** @type {?} */
        var toValidate = ["employee"];
        if (!toValidate.every((/**
         * @param {?} e
         * @return {?}
         */
        function (e) { return _this.allPermissions[e] && _this.allPermissions[e].visualizar; }))) {
            this.router.navigate(["forbidden"]);
        }
        /*{CA:VALIDATE_VISUALIZATION_END:START}*/
        /*{CA:VALIDATE_VISUALIZATION_END:END}*/
    };
    /**
     * @private
     * @return {?}
     */
    BridgeFormComponent.prototype.validLimitDaysBackwardScheduling = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        return (/**
         * @param {?} control
         * @return {?}
         */
        function (control) {
            /** @type {?} */
            var originDate = control.get("originDate");
            /** @type {?} */
            var employee = control.get("employee");
            if (employee.value && originDate.value) {
                /** @type {?} */
                var limitDate = _this.cacheLimitDaysBackwardScheduling.get(employee.value.employer.id);
                if (limitDate && moment$4(originDate.value).isBefore(limitDate, "day")) {
                    originDate.setErrors({ exceededLimit: { value: originDate.value } });
                }
                else {
                    removeErrorFromField(originDate, "exceededLimit");
                }
            }
            return null;
        });
    };
    /**
     * @private
     * @return {?}
     */
    BridgeFormComponent.prototype.startDateIsBeforeEndDate = /**
     * @private
     * @return {?}
     */
    function () {
        return (/**
         * @param {?} control
         * @return {?}
         */
        function (control) {
            /** @type {?} */
            var originDate = control.get("originDate");
            /** @type {?} */
            var destinationDate = control.get("destinationDate");
            startDateIsBeforeEndDateValidator(originDate, destinationDate);
            return null;
        });
    };
    /*{CA:CLASS_METHODS:END}*/
    /*{CA:CLASS_METHODS:END}*/
    /**
     * @private
     * @param {?} severity
     * @param {?} summary
     * @param {?} detail
     * @return {?}
     */
    BridgeFormComponent.prototype.addMessage = /*{CA:CLASS_METHODS:END}*/
    /**
     * @private
     * @param {?} severity
     * @param {?} summary
     * @param {?} detail
     * @return {?}
     */
    function (severity, summary, detail) {
        this.messageService.add({
            severity: severity,
            summary: this.translate.instant(summary),
            detail: this.translate.instant(detail),
        });
    };
    BridgeFormComponent.decorators = [
        { type: Component, args: [{
                    template: "<div *ngIf=\"!customTemplate else customTemplate\">\n    <p-confirmDialog acceptLabel=\"{{'hcm_clocking_event_foundation.general.yes' | translate}}\" acceptIcon=\"\"\n        rejectLabel=\"{{'hcm_clocking_event_foundation.general.no' | translate}}\" rejectIcon=\"\">\n    </p-confirmDialog>\n    <form [formGroup]=\"formGroup\" novalidate>\n        <p-panel *sLoadingState=\"loading\" [styleClass]=\"lockedEmployee ? 'form-group sidebar-panel' : 'form-group'\" \n            [toggleable]=\"false\" [collapsed]=\"mainPanelCollapsed\" [showHeader]=\"!lockedEmployee\">\n            <p-header>\n                {{\"hcm_clocking_event_foundation.general.bridge_form_general_title\" | translate}}\n            </p-header>\n            <div class=\"ui-fluid\" *ngIf=\"!customFormFields else customFormFields\">\n                <div class=\"ui-g\">\n                    <div [attr.data-hidden]=\"true\" class=\"ui-g-12 ui-md-6\">\n                        <label for=\"id\">{{\"hcm_clocking_event_foundation.general.bridge_id\" | translate}}</label>\n                        <input #idFormInput type=\"text\" id=\"id\" name=\"id\" pInputText formControlName=\"id\" autocomplete=\"off\"\n                        />\n                    </div> \n                    <div [attr.data-hidden]=\"!allPermissions?.employee.visualizar\" class=\"ui-g-12 ui-md-6 required\">\n                        <label for=\"employee\">{{\"hcm_clocking_event_foundation.general.bridge_employee\" | translate}}</label>\n                        <s-lookup dataKey=\"id\" id=\"employee\" name=\"employee\" formControlName=\"employee\" [searchFields]=\"employeeSearchGridFields\"\n                        [searchGridFields]=\"employeeSearchGridFields\" [searchGridData]=\"employeeSearchGridData\"\n                        [multiple]=\"false\" [lookupSuggestions]=\"employeeLookupSuggestions\" (onLookupRequest)=\"onEmployeeLookupRequest($event)\"\n                        (onSearchRequest)=\"onEmployeeSearchRequest($event)\" lookupDisplayField=\"label\"\n                        [searchTotalRecords]=employeeSearchTotalRecords [searchTitle]=\"'hcm_clocking_event_foundation.general.bridge_employee_search_title' | translate\"\n                        [searchEmptyTitle]=\"'hcm_clocking_event_foundation.general.nothing_found' | translate\"\n                        [filterLabel]=\"'hcm_clocking_event_foundation.general.filter' | translate\" [filterTitle]=\"'hcm_clocking_event_foundation.general.filters' | translate\"\n                        [clearLabel]=\"'hcm_clocking_event_foundation.general.clear' | translate\" [cancelLabel]=\"'hcm_clocking_event_foundation.general.cancel' | translate\"\n                        [selectLabel]=\"'hcm_clocking_event_foundation.general.select' | translate\" [searchTotalRecordsLabel]=\"'hcm_clocking_event_foundation.general.total_records' | translate: {value: employeeSearchTotalRecords}\"></s-lookup>\n                        <s-control-errors [control]=\"formGroup.controls['employee']\"\n                        [errorMessages]=\"{\n                            required: 'hcm_clocking_event_foundation.general.error_required' | translate,\n                            hasNotCompanyClockingEventIndications: 'hcm_clocking_event_foundation.general.error_company_of_employee_need_time_evaluation_definition' | translate\n                        }\"\n                        ></s-control-errors>\n                    </div>\n                    <div class=\"ui-md-6\"></div>\n                    <div class=\"ui-g-12 ui-md-6 required\">\n                        <label for=\"originDate\">{{\"hcm_clocking_event_foundation.general.bridge_origin_date\" | translate}}</label>\n                        <p-calendar #originDateFormInput inputId=\"originDate\" name=\"originDate\" [showIcon]=\"true\" formControlName=\"originDate\"\n                            [locale]=\"localeConfig.calendar\" [dateFormat]=\"localeConfig.calendar.dateFormat\"></p-calendar>\n                        <s-control-errors [control]=\"formGroup.controls['originDate']\"\n                            [errorMessages]=\"{\n                                required: 'hcm_clocking_event_foundation.general.error_required' | translate,\n                                exceededLimit: 'hcm_clocking_event_foundation.general.error_exceeded_limit_days_backward_scheduling' | translate, \n                                startDateIsBeforeEndDate: 'hcm_clocking_event_foundation.general.error_origin_date_after_destination_date_to_start_date' | translate\n                            }\"\n                        ></s-control-errors>\n                    </div>\n                    <div class=\"ui-g-12 ui-md-6 required\">\n                        <label for=\"destinationDate\">{{\"hcm_clocking_event_foundation.general.bridge_destination_date\" | translate}}</label>\n                        <p-calendar #destinationDateFormInput inputId=\"destinationDate\" name=\"destinationDate\" [showIcon]=\"true\"\n                            formControlName=\"destinationDate\" [locale]=\"localeConfig.calendar\" [dateFormat]=\"localeConfig.calendar.dateFormat\"></p-calendar>\n                        <s-control-errors [control]=\"formGroup.controls['destinationDate']\"\n                            [errorMessages]=\"{\n                                required: 'hcm_clocking_event_foundation.general.error_required' | translate,\n                                startDateIsBeforeEndDate: 'hcm_clocking_event_foundation.general.error_origin_date_after_destination_date_to_end_date' | translate\n                            }\"\n                        ></s-control-errors>\n                    </div>\n                </div>\n            </div>\n            <s-custom-fields domain=\"hcm_clocking_event_foundation\" service=\"general\" entity=\"bridge\" formControlName=\"custom\"\n                [invalidErrorLabel]=\"'hcm_clocking_event_foundation.general.error_invalid' | translate\"></s-custom-fields>\n            <div class=\"ui-g\" *ngIf=\"!isNew() && !lockedEmployee\">\n                <div class=\"ui-g-12 ui-inputgroup\"> \n                    <label *ngIf=\"formGroup.get('createdBy').value !== ''\" style=\"color: #a3a3a3; margin-right: 2px;\">{{'hcm_clocking_event_foundation.general.created_by' | translate}} {{formGroup.get('createdBy').value}} {{'hcm_clocking_event_foundation.general.at_date' | translate}} {{formGroup.get('createdDate').value | date: 'dd/MM/yyyy'}} {{'hcm_clocking_event_foundation.general.at_time' | translate}} {{formGroup.get('createdDate').value | date: 'HH:mm'}}. </label>\n                    <label *ngIf=\"formGroup.get('lastModifiedBy').value !== ''\" style=\"color: #a3a3a3;\">{{'hcm_clocking_event_foundation.general.updated_by' | translate}} {{formGroup.get('lastModifiedBy').value}} {{'hcm_clocking_event_foundation.general.at_date' | translate}} {{formGroup.get('lastModifiedDate').value | date: 'dd/MM/yyyy'}} {{'hcm_clocking_event_foundation.general.at_time' | translate}} {{formGroup.get('lastModifiedDate').value | date: 'HH:mm'}}.</label>\n                </div>\n            </div>\n            <p-footer *ngIf=\"!lockedEmployee\">\n                <button id=\"save-button\" title=\"{{'hcm_clocking_event_foundation.general.save' | translate}} (Alt + Shift + S)\"\n                    type=\"submit\" pButton label=\"{{'hcm_clocking_event_foundation.general.save' | translate}}\"\n                    (click)=\"onSave()\" *ngIf=\"isNew() || permissions.editar\"></button>\n                <button id=\"delete-button\" title=\"{{'hcm_clocking_event_foundation.general.delete' | translate}} (Alt + Shift + X)\"\n                    type=\"button\" class=\"ui-button-secondary\" pButton label=\"{{'hcm_clocking_event_foundation.general.delete' | translate}}\"\n                    (click)=\"onDelete()\" *ngIf=\"!isNew() && permissions.excluir\" [disabled]=\"loading\"></button>\n                <button id=\"cancel-button\" title=\"{{'hcm_clocking_event_foundation.general.cancel' | translate}} (Alt + Shift + C)\"\n                    type=\"button\" class=\"ui-button-link\" pButton label=\"{{'hcm_clocking_event_foundation.general.cancel' | translate}}\"\n                    (click)=\"onCancel()\"></button>\n            </p-footer>\n        </p-panel>\n    </form>\n</div>\n<!--{CA:FILE_CONTENTS:START}-->\n<!--{CA:FILE_CONTENTS:END}-->\n",
                    providers: [
                        ConfirmationService,
                    ],
                    selector: "cem-bridge-form",
                    styles: [":host ::ng-deep .sidebar-panel{border:none!important;padding-left:0!important}"]
                }] }
    ];
    /** @nocollapse */
    BridgeFormComponent.ctorParameters = function () { return [
        { type: CompanyClockingEventIndicationsService },
        { type: BridgeService },
        { type: Router },
        { type: ActivatedRoute },
        { type: MessageService },
        { type: ConfirmationService },
        { type: FormBuilder },
        { type: TranslateService },
        { type: HotkeysService },
        { type: FieldCustomizationService },
        { type: FocusService },
        { type: EmployeeService }
    ]; };
    BridgeFormComponent.propDecorators = {
        customTemplate: [{ type: ViewChild, args: ["customTemplate", { static: false },] }],
        customFormFields: [{ type: ViewChild, args: ["customFormFields", { static: false },] }],
        onSubmitObservable: [{ type: Input }],
        onLockedEmployeeChanges: [{ type: Input }],
        lockedEmployee: [{ type: Input }],
        onCloseObservable: [{ type: Output }]
    };
    return BridgeFormComponent;
}());
if (false) {
    /** @type {?} */
    BridgeFormComponent.prototype.localeConfig;
    /** @type {?} */
    BridgeFormComponent.prototype.currencyLocaleOptions;
    /** @type {?} */
    BridgeFormComponent.prototype.permissions;
    /** @type {?} */
    BridgeFormComponent.prototype.allPermissions;
    /** @type {?} */
    BridgeFormComponent.prototype.formGroup;
    /** @type {?} */
    BridgeFormComponent.prototype.loading;
    /** @type {?} */
    BridgeFormComponent.prototype.mainPanelCollapsed;
    /** @type {?} */
    BridgeFormComponent.prototype.contractTypeOptions;
    /** @type {?} */
    BridgeFormComponent.prototype.employeeLookupSuggestions;
    /** @type {?} */
    BridgeFormComponent.prototype.employeeLookupDisplayFields;
    /** @type {?} */
    BridgeFormComponent.prototype.employeeAdvancedDisplayFields;
    /** @type {?} */
    BridgeFormComponent.prototype.employeeLookupSeparator;
    /** @type {?} */
    BridgeFormComponent.prototype.employeeSearchFields;
    /** @type {?} */
    BridgeFormComponent.prototype.employeeSearchGridFields;
    /** @type {?} */
    BridgeFormComponent.prototype.employeeSearchGridData;
    /** @type {?} */
    BridgeFormComponent.prototype.employeeSearchTotalRecords;
    /** @type {?} */
    BridgeFormComponent.prototype.customTemplate;
    /** @type {?} */
    BridgeFormComponent.prototype.customFormFields;
    /** @type {?} */
    BridgeFormComponent.prototype.cacheLimitDaysBackwardScheduling;
    /** @type {?} */
    BridgeFormComponent.prototype.onSubmitObservable;
    /** @type {?} */
    BridgeFormComponent.prototype.onLockedEmployeeChanges;
    /** @type {?} */
    BridgeFormComponent.prototype.lockedEmployee;
    /**
     * @type {?}
     * @private
     */
    BridgeFormComponent.prototype.onClose;
    /** @type {?} */
    BridgeFormComponent.prototype.onCloseObservable;
    /**
     * @type {?}
     * @private
     */
    BridgeFormComponent.prototype.routeParams;
    /**
     * @type {?}
     * @private
     */
    BridgeFormComponent.prototype.ngUnsubscribe;
    /**
     * @type {?}
     * @private
     */
    BridgeFormComponent.prototype.companyClockingEventIndicationsService;
    /**
     * @type {?}
     * @private
     */
    BridgeFormComponent.prototype.bridgeService;
    /**
     * @type {?}
     * @private
     */
    BridgeFormComponent.prototype.router;
    /**
     * @type {?}
     * @private
     */
    BridgeFormComponent.prototype.route;
    /**
     * @type {?}
     * @private
     */
    BridgeFormComponent.prototype.messageService;
    /**
     * @type {?}
     * @private
     */
    BridgeFormComponent.prototype.confirmationService;
    /**
     * @type {?}
     * @private
     */
    BridgeFormComponent.prototype.formBuilder;
    /**
     * @type {?}
     * @private
     */
    BridgeFormComponent.prototype.translate;
    /**
     * @type {?}
     * @private
     */
    BridgeFormComponent.prototype.hotkeysService;
    /**
     * @type {?}
     * @private
     */
    BridgeFormComponent.prototype.fieldCustomization;
    /**
     * @type {?}
     * @private
     */
    BridgeFormComponent.prototype.focusService;
    /**
     * @type {?}
     * @private
     */
    BridgeFormComponent.prototype.employeeService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/bridge/bridge-form.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BridgeFormModule = /** @class */ (function () {
    function BridgeFormModule() {
    }
    BridgeFormModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        LocaleModule.forChild(),
                        SharedScheduleModule,
                        CoreSchedulesHistoriesModule
                    ],
                    declarations: [
                        BridgeFormComponent
                    ],
                    exports: [
                        BridgeFormComponent
                    ]
                },] }
    ];
    return BridgeFormModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: core/dtos/employee-date.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function EmployeeDate() { }
if (false) {
    /** @type {?} */
    EmployeeDate.prototype.evaluationDate;
    /** @type {?} */
    EmployeeDate.prototype.employeeId;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/bridge/bridge-dto.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function BridgeDto() { }
if (false) {
    /** @type {?|undefined} */
    BridgeDto.prototype.id;
    /** @type {?} */
    BridgeDto.prototype.employee;
    /** @type {?} */
    BridgeDto.prototype.originDate;
    /** @type {?} */
    BridgeDto.prototype.destinationDate;
    /** @type {?|undefined} */
    BridgeDto.prototype.createdBy;
    /** @type {?|undefined} */
    BridgeDto.prototype.createdDate;
    /** @type {?|undefined} */
    BridgeDto.prototype.lastModifiedBy;
    /** @type {?|undefined} */
    BridgeDto.prototype.lastModifiedDate;
    /** @type {?|undefined} */
    BridgeDto.prototype.custom;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/bridge/index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/situation/situation.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PACKAGE_IMPORTS:START}*/
/** @type {?} */
var moment$5 = moment_;
// @HACK Necessary because of https://github.com/rollup/rollup/issues/670
/*{CA:PACKAGE_IMPORTS:END}*/
var  
// @HACK Necessary because of https://github.com/rollup/rollup/issues/670
/*{CA:PACKAGE_IMPORTS:END}*/
Situation = /** @class */ (function () {
    function Situation() {
        this.deleted = false;
        /*{CA:CLASS_METHODS:START}*/
        /*{CA:CLASS_METHODS:END}*/
    }
    /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/
    /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/
    /**
     * @param {?} situationDto
     * @param {?=} originEntity
     * @return {?}
     */
    Situation.fromDto = /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/
    /**
     * @param {?} situationDto
     * @param {?=} originEntity
     * @return {?}
     */
    function (situationDto, originEntity) {
        /** @type {?} */
        var model = __assign({}, situationDto);
        model.createdDate = model.createdDate && moment$5(model.createdDate).toDate();
        model.lastModifiedDate = model.lastModifiedDate && moment$5(model.lastModifiedDate).toDate();
        /** @type {?} */
        var lookupSeparator = " - ";
        /** @type {?} */
        var displayFields = ["code", "name"];
        model.label = displayFields.map((/**
         * @param {?} field
         * @return {?}
         */
        function (field) { return model[field]; })).join(lookupSeparator);
        return (/** @type {?} */ (model));
    };
    /**
     * @param {?} situation
     * @param {?=} originEntity
     * @return {?}
     */
    Situation.toDto = /**
     * @param {?} situation
     * @param {?=} originEntity
     * @return {?}
     */
    function (situation, originEntity) {
        /** @type {?} */
        var dto = __assign({}, situation);
        dto.createdDate = dto.createdDate && moment$5(dto.createdDate).format();
        dto.lastModifiedDate = dto.lastModifiedDate && moment$5(dto.lastModifiedDate).format();
        delete dto.label;
        return dto;
    };
    return Situation;
}());
if (false) {
    /** @type {?} */
    Situation.prototype.id;
    /** @type {?} */
    Situation.prototype.code;
    /** @type {?} */
    Situation.prototype.name;
    /** @type {?} */
    Situation.prototype.deleted;
    /** @type {?} */
    Situation.prototype.extIntSts;
    /** @type {?} */
    Situation.prototype.extIntMsg;
    /** @type {?} */
    Situation.prototype.createdBy;
    /** @type {?} */
    Situation.prototype.createdDate;
    /** @type {?} */
    Situation.prototype.lastModifiedBy;
    /** @type {?} */
    Situation.prototype.lastModifiedDate;
    /** @type {?} */
    Situation.prototype.custom;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/time-evaluation-definition/time-evaluation-definition.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PACKAGE_IMPORTS:START}*/
/*{CA:PACKAGE_IMPORTS:END}*/
/*{CA:PROJECT_IMPORTS:START}*/
/** @type {?} */
var moment$6 = moment_;
// @HACK Necessary because of https://github.com/rollup/rollup/issues/670
/*{CA:PROJECT_IMPORTS:END}*/
var  
// @HACK Necessary because of https://github.com/rollup/rollup/issues/670
/*{CA:PROJECT_IMPORTS:END}*/
TimeEvaluationDefinition = /** @class */ (function () {
    function TimeEvaluationDefinition() {
    }
    /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/
    /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/
    /**
     * @param {?} timeEvaluationDefinitionDto
     * @param {?=} originEntity
     * @return {?}
     */
    TimeEvaluationDefinition.fromDto = /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/
    /**
     * @param {?} timeEvaluationDefinitionDto
     * @param {?=} originEntity
     * @return {?}
     */
    function (timeEvaluationDefinitionDto, originEntity) {
        /** @type {?} */
        var model = __assign({}, timeEvaluationDefinitionDto);
        model.createdDate = model.createdDate && moment$6(model.createdDate).toDate();
        model.lastModifiedDate = model.lastModifiedDate && moment$6(model.lastModifiedDate).toDate();
        /** @type {?} */
        var lookupSeparator = " - ";
        /** @type {?} */
        var displayFields = ["code", "name"];
        model.label = displayFields.map((/**
         * @param {?} field
         * @return {?}
         */
        function (field) { return model[field]; })).join(lookupSeparator);
        if (originEntity !== "Situation" && model.incompleteJourneySituation)
            model.incompleteJourneySituation = Situation.fromDto(model.incompleteJourneySituation, "TimeEvaluationDefinition");
        return (/** @type {?} */ (model));
    };
    /**
     * @param {?} timeEvaluationDefinition
     * @param {?=} originEntity
     * @return {?}
     */
    TimeEvaluationDefinition.toDto = /**
     * @param {?} timeEvaluationDefinition
     * @param {?=} originEntity
     * @return {?}
     */
    function (timeEvaluationDefinition, originEntity) {
        /** @type {?} */
        var dto = __assign({}, timeEvaluationDefinition);
        dto.createdDate = dto.createdDate && moment$6(dto.createdDate).format();
        dto.lastModifiedDate = dto.lastModifiedDate && moment$6(dto.lastModifiedDate).format();
        delete dto.label;
        if (originEntity !== "Situation" && dto.incompleteJourneySituation)
            dto.incompleteJourneySituation = Situation.toDto(dto.incompleteJourneySituation, "TimeEvaluationDefinition");
        return dto;
    };
    return TimeEvaluationDefinition;
}());
if (false) {
    /** @type {?} */
    TimeEvaluationDefinition.prototype.id;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.code;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.name;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.useWorkscheduleDayOff;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.verifiedDaysControl;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.controlAdjustmentReason;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.controlObservation;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.daysResume;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.clockingEventTolerance;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.retroactiveAdjustment;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.evaluateIncompleteJourney;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.incompleteJourneySituation;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.numberOfDaysAdjustment;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.calculateHolidayAbsenceRotationWorkshift;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.considerClockingEventInterval;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.clockingEventInterval;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.schedulingOverlapsHoliday;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.limitDaysBackwardScheduling;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.bridgeOverlapsWorkscheduleChange;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.allowClockingEventModificationBeforeTransference;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.calculateReadiness;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.discountHoursWorkedReadiness;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.expirationDays;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.limitOfDaysAfterPointClosing;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.blockPendingAfterExpires;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.allowsTakeLedgerPending;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.allowsCompleteUntreatedPending;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.createdBy;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.createdDate;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.lastModifiedBy;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.lastModifiedDate;
    /** @type {?} */
    TimeEvaluationDefinition.prototype.custom;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/time-evaluation-situation-definition/time-evaluation-situation-definition.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PACKAGE_IMPORTS:START}*/
/** @type {?} */
var moment$7 = moment_;
// @HACK Necessary because of https://github.com/rollup/rollup/issues/670
/*{CA:PACKAGE_IMPORTS:END}*/
var  
// @HACK Necessary because of https://github.com/rollup/rollup/issues/670
/*{CA:PACKAGE_IMPORTS:END}*/
TimeEvaluationSituationDefinition = /** @class */ (function () {
    function TimeEvaluationSituationDefinition() {
    }
    /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/
    /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/
    /**
     * @param {?} timeEvaluationSituationDefinitionDto
     * @param {?=} originEntity
     * @return {?}
     */
    TimeEvaluationSituationDefinition.fromDto = /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/
    /**
     * @param {?} timeEvaluationSituationDefinitionDto
     * @param {?=} originEntity
     * @return {?}
     */
    function (timeEvaluationSituationDefinitionDto, originEntity) {
        /** @type {?} */
        var model = __assign({}, timeEvaluationSituationDefinitionDto);
        model.createdDate = model.createdDate && moment$7(model.createdDate).toDate();
        model.lastModifiedDate = model.lastModifiedDate && moment$7(model.lastModifiedDate).toDate();
        /** @type {?} */
        var lookupSeparator = " - ";
        /** @type {?} */
        var displayFields = ["code", "name"];
        model.label = displayFields.map((/**
         * @param {?} field
         * @return {?}
         */
        function (field) { return model[field]; })).join(lookupSeparator);
        return (/** @type {?} */ (model));
    };
    /**
     * @param {?} timeEvaluationSituationDefinition
     * @param {?=} originEntity
     * @return {?}
     */
    TimeEvaluationSituationDefinition.toDto = /**
     * @param {?} timeEvaluationSituationDefinition
     * @param {?=} originEntity
     * @return {?}
     */
    function (timeEvaluationSituationDefinition, originEntity) {
        /** @type {?} */
        var dto = __assign({}, timeEvaluationSituationDefinition);
        dto.createdDate = dto.createdDate && moment$7(dto.createdDate).format();
        dto.lastModifiedDate = dto.lastModifiedDate && moment$7(dto.lastModifiedDate).format();
        delete dto.label;
        return dto;
    };
    return TimeEvaluationSituationDefinition;
}());
if (false) {
    /** @type {?} */
    TimeEvaluationSituationDefinition.prototype.id;
    /** @type {?} */
    TimeEvaluationSituationDefinition.prototype.code;
    /** @type {?} */
    TimeEvaluationSituationDefinition.prototype.name;
    /** @type {?} */
    TimeEvaluationSituationDefinition.prototype.createdBy;
    /** @type {?} */
    TimeEvaluationSituationDefinition.prototype.createdDate;
    /** @type {?} */
    TimeEvaluationSituationDefinition.prototype.lastModifiedBy;
    /** @type {?} */
    TimeEvaluationSituationDefinition.prototype.lastModifiedDate;
    /** @type {?} */
    TimeEvaluationSituationDefinition.prototype.custom;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/company-clocking-event-indications/company-clocking-event-indications.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var moment$8 = moment_;
// @HACK Necessary because of https://github.com/rollup/rollup/issues/670
var  
// @HACK Necessary because of https://github.com/rollup/rollup/issues/670
CompanyClockingEventIndications = /** @class */ (function () {
    function CompanyClockingEventIndications() {
    }
    /**
     * @param {?} companyClockingEventIndicationsDto
     * @param {?=} originEntity
     * @return {?}
     */
    CompanyClockingEventIndications.fromDto = /**
     * @param {?} companyClockingEventIndicationsDto
     * @param {?=} originEntity
     * @return {?}
     */
    function (companyClockingEventIndicationsDto, originEntity) {
        /** @type {?} */
        var model = __assign({}, companyClockingEventIndicationsDto);
        model.createdDate = model.createdDate && moment$8(model.createdDate).toDate();
        model.lastModifiedDate = model.lastModifiedDate && moment$8(model.lastModifiedDate).toDate();
        /** @type {?} */
        var lookupSeparator = " - ";
        /** @type {?} */
        var displayFields = [
            "timeEvaluationDefinition.code",
            "timeEvaluationDefinition.name",
            "timeEvaluationSituationDefinition.code",
            "timeEvaluationSituationDefinition.name",
        ];
        model.label = displayFields.map((/**
         * @param {?} field
         * @return {?}
         */
        function (field) { return model[field]; })).join(lookupSeparator);
        if (originEntity !== "TimeEvaluationDefinition" && model.timeEvaluationDefinition)
            model.timeEvaluationDefinition = TimeEvaluationDefinition.fromDto(model.timeEvaluationDefinition, "CompanyClockingEventIndications");
        if (originEntity !== "TimeEvaluationSituationDefinition" && model.timeEvaluationSituationDefinition)
            model.timeEvaluationSituationDefinition = TimeEvaluationSituationDefinition.fromDto(model.timeEvaluationSituationDefinition, "CompanyClockingEventIndications");
        return (/** @type {?} */ (model));
    };
    /**
     * @param {?} companyClockingEventIndications
     * @param {?=} originEntity
     * @return {?}
     */
    CompanyClockingEventIndications.toDto = /**
     * @param {?} companyClockingEventIndications
     * @param {?=} originEntity
     * @return {?}
     */
    function (companyClockingEventIndications, originEntity) {
        /** @type {?} */
        var dto = __assign({}, companyClockingEventIndications);
        dto.createdDate = dto.createdDate && moment$8(dto.createdDate).format();
        dto.lastModifiedDate = dto.lastModifiedDate && moment$8(dto.lastModifiedDate).format();
        delete dto.label;
        if (originEntity !== "TimeEvaluationDefinition" && dto.timeEvaluationDefinition)
            dto.timeEvaluationDefinition = TimeEvaluationDefinition.toDto(dto.timeEvaluationDefinition, "CompanyClockingEventIndications");
        if (originEntity !== "TimeEvaluationSituationDefinition" && dto.timeEvaluationSituationDefinition)
            dto.timeEvaluationSituationDefinition = TimeEvaluationSituationDefinition.toDto(dto.timeEvaluationSituationDefinition, "CompanyClockingEventIndications");
        return dto;
    };
    return CompanyClockingEventIndications;
}());
if (false) {
    /** @type {?} */
    CompanyClockingEventIndications.prototype.id;
    /** @type {?} */
    CompanyClockingEventIndications.prototype.timeEvaluationDefinition;
    /** @type {?} */
    CompanyClockingEventIndications.prototype.timeEvaluationSituationDefinition;
    /** @type {?} */
    CompanyClockingEventIndications.prototype.createdBy;
    /** @type {?} */
    CompanyClockingEventIndications.prototype.createdDate;
    /** @type {?} */
    CompanyClockingEventIndications.prototype.lastModifiedBy;
    /** @type {?} */
    CompanyClockingEventIndications.prototype.lastModifiedDate;
    /** @type {?} */
    CompanyClockingEventIndications.prototype.custom;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/company-clocking-event-indications/company-clocking-event-indications-dto.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function CompanyClockingEventIndicationsDto() { }
if (false) {
    /** @type {?|undefined} */
    CompanyClockingEventIndicationsDto.prototype.id;
    /** @type {?|undefined} */
    CompanyClockingEventIndicationsDto.prototype.company;
    /** @type {?} */
    CompanyClockingEventIndicationsDto.prototype.timeEvaluationDefinition;
    /** @type {?} */
    CompanyClockingEventIndicationsDto.prototype.timeEvaluationSituationDefinition;
    /** @type {?|undefined} */
    CompanyClockingEventIndicationsDto.prototype.createdBy;
    /** @type {?|undefined} */
    CompanyClockingEventIndicationsDto.prototype.createdDate;
    /** @type {?|undefined} */
    CompanyClockingEventIndicationsDto.prototype.lastModifiedBy;
    /** @type {?|undefined} */
    CompanyClockingEventIndicationsDto.prototype.lastModifiedDate;
    /** @type {?|undefined} */
    CompanyClockingEventIndicationsDto.prototype.custom;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/company-clocking-event-indications/index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/e-001-pes/e-001-pes-dto.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function E001PesDto() { }
if (false) {
    /** @type {?|undefined} */
    E001PesDto.prototype.id;
    /** @type {?} */
    E001PesDto.prototype.nomPes;
    /** @type {?|undefined} */
    E001PesDto.prototype.excluido;
    /** @type {?|undefined} */
    E001PesDto.prototype.extIntSts;
    /** @type {?|undefined} */
    E001PesDto.prototype.extIntMsg;
    /** @type {?|undefined} */
    E001PesDto.prototype.createdBy;
    /** @type {?|undefined} */
    E001PesDto.prototype.createdDate;
    /** @type {?|undefined} */
    E001PesDto.prototype.lastModifiedBy;
    /** @type {?|undefined} */
    E001PesDto.prototype.lastModifiedDate;
    /** @type {?|undefined} */
    E001PesDto.prototype.custom;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/e-001-pes/index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/employee/employee-dto.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function EmployeeDto() { }
if (false) {
    /** @type {?|undefined} */
    EmployeeDto.prototype.id;
    /** @type {?} */
    EmployeeDto.prototype.code;
    /** @type {?|undefined} */
    EmployeeDto.prototype.employmentRelationship;
    /** @type {?|undefined} */
    EmployeeDto.prototype.employer;
    /** @type {?|undefined} */
    EmployeeDto.prototype.person;
    /** @type {?|undefined} */
    EmployeeDto.prototype.hireDate;
    /** @type {?|undefined} */
    EmployeeDto.prototype.dismissalDate;
    /** @type {?|undefined} */
    EmployeeDto.prototype.deleted;
    /** @type {?|undefined} */
    EmployeeDto.prototype.extIntSts;
    /** @type {?|undefined} */
    EmployeeDto.prototype.extIntMsg;
    /** @type {?|undefined} */
    EmployeeDto.prototype.createdBy;
    /** @type {?|undefined} */
    EmployeeDto.prototype.createdDate;
    /** @type {?|undefined} */
    EmployeeDto.prototype.lastModifiedBy;
    /** @type {?|undefined} */
    EmployeeDto.prototype.lastModifiedDate;
    /** @type {?|undefined} */
    EmployeeDto.prototype.custom;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/employee/index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/situation/situation-dto.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PACKAGE_IMPORTS:START}*/
/*{CA:PACKAGE_IMPORTS:END}*/
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
/**
 * @record
 */
function SituationDto() { }
if (false) {
    /** @type {?|undefined} */
    SituationDto.prototype.id;
    /** @type {?} */
    SituationDto.prototype.code;
    /** @type {?} */
    SituationDto.prototype.name;
    /** @type {?|undefined} */
    SituationDto.prototype.deleted;
    /** @type {?|undefined} */
    SituationDto.prototype.extIntSts;
    /** @type {?|undefined} */
    SituationDto.prototype.extIntMsg;
    /** @type {?|undefined} */
    SituationDto.prototype.createdBy;
    /** @type {?|undefined} */
    SituationDto.prototype.createdDate;
    /** @type {?|undefined} */
    SituationDto.prototype.lastModifiedBy;
    /** @type {?|undefined} */
    SituationDto.prototype.lastModifiedDate;
    /** @type {?|undefined} */
    SituationDto.prototype.custom;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/situation/index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/time-evaluation-definition/time-evaluation-definition-dto.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PACKAGE_IMPORTS:START}*/
/*{CA:PACKAGE_IMPORTS:END}*/
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
/**
 * @record
 */
function TimeEvaluationDefinitionDto() { }
if (false) {
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.id;
    /** @type {?} */
    TimeEvaluationDefinitionDto.prototype.code;
    /** @type {?} */
    TimeEvaluationDefinitionDto.prototype.name;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.useWorkscheduleDayOff;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.verifiedDaysControl;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.controlAdjustmentReason;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.controlObservation;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.daysResume;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.clockingEventTolerance;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.retroactiveAdjustment;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.evaluateIncompleteJourney;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.incompleteJourneySituation;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.numberOfDaysAdjustment;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.calculateHolidayAbsenceRotationWorkshift;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.considerClockingEventInterval;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.clockingEventInterval;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.schedulingOverlapsHoliday;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.limitDaysBackwardScheduling;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.bridgeOverlapsWorkscheduleChange;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.allowClockingEventModificationBeforeTransference;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.calculateReadiness;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.discountHoursWorkedReadiness;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.expirationDays;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.limitOfDaysAfterPointClosing;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.blockPendingAfterExpires;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.allowsTakeLedgerPending;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.allowsCompleteUntreatedPending;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.createdBy;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.createdDate;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.lastModifiedBy;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.lastModifiedDate;
    /** @type {?|undefined} */
    TimeEvaluationDefinitionDto.prototype.custom;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/time-evaluation-definition/index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/time-evaluation-situation-definition/time-evaluation-situation-definition-dto.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PACKAGE_IMPORTS:START}*/
/*{CA:PACKAGE_IMPORTS:END}*/
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
/**
 * @record
 */
function TimeEvaluationSituationDefinitionDto() { }
if (false) {
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionDto.prototype.id;
    /** @type {?} */
    TimeEvaluationSituationDefinitionDto.prototype.code;
    /** @type {?} */
    TimeEvaluationSituationDefinitionDto.prototype.name;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionDto.prototype.createdBy;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionDto.prototype.createdDate;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionDto.prototype.lastModifiedBy;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionDto.prototype.lastModifiedDate;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionDto.prototype.custom;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/time-evaluation-situation-definition/index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/situation-clocking-event/situation-clocking-event.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PROJECT_IMPORTS:START}*/
/** @type {?} */
var moment$9 = moment_;
// @HACK Necessary because of https://github.com/rollup/rollup/issues/670
/*{CA:PROJECT_IMPORTS:END}*/
var  
// @HACK Necessary because of https://github.com/rollup/rollup/issues/670
/*{CA:PROJECT_IMPORTS:END}*/
SituationClockingEvent = /** @class */ (function () {
    function SituationClockingEvent() {
        this.daytimeSituation = false;
        /*{CA:CLASS_METHODS:START}*/
        /*{CA:CLASS_METHODS:END}*/
    }
    /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/
    /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/
    /**
     * @param {?} situationClockingEventDto
     * @param {?=} originEntity
     * @return {?}
     */
    SituationClockingEvent.fromDto = /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/
    /**
     * @param {?} situationClockingEventDto
     * @param {?=} originEntity
     * @return {?}
     */
    function (situationClockingEventDto, originEntity) {
        /** @type {?} */
        var model = __assign({}, situationClockingEventDto);
        model.createdDate = model.createdDate && moment$9(model.createdDate).toDate();
        model.lastModifiedDate = model.lastModifiedDate && moment$9(model.lastModifiedDate).toDate();
        /** @type {?} */
        var lookupSeparator = " - ";
        /** @type {?} */
        var displayFields = [
            "id",
            "complementarySituation.code",
            "complementarySituation.name",
            "exceptionSituation",
            "mandatoryAdjustmentReason",
            "daytimeSituation",
            "convertNightHours",
            "obligateAttachmentOnLeave",
            "createdBy",
            "createdDate",
            "lastModifiedBy",
            "lastModifiedDate",
        ];
        model.label = displayFields.map((/**
         * @param {?} field
         * @return {?}
         */
        function (field) { return model[field]; })).join(lookupSeparator);
        if (originEntity !== "Situation" && model.situation)
            model.situation = Situation.fromDto(model.situation, "SituationClockingEvent");
        if (originEntity !== "Situation" && model.complementarySituation)
            model.complementarySituation = Situation.fromDto(model.complementarySituation, "SituationClockingEvent");
        return (/** @type {?} */ (model));
    };
    /**
     * @param {?} situationClockingEvent
     * @param {?=} originEntity
     * @return {?}
     */
    SituationClockingEvent.toDto = /**
     * @param {?} situationClockingEvent
     * @param {?=} originEntity
     * @return {?}
     */
    function (situationClockingEvent, originEntity) {
        /** @type {?} */
        var dto = __assign({}, situationClockingEvent);
        dto.createdDate = dto.createdDate && moment$9(dto.createdDate).format();
        dto.lastModifiedDate = dto.lastModifiedDate && moment$9(dto.lastModifiedDate).format();
        delete dto.label;
        if (originEntity !== "Situation" && dto.situation)
            dto.situation = Situation.toDto(dto.situation, "SituationClockingEvent");
        if (originEntity !== "Situation" && dto.complementarySituation)
            dto.complementarySituation = Situation.toDto(dto.complementarySituation, "SituationClockingEvent");
        return dto;
    };
    return SituationClockingEvent;
}());
if (false) {
    /** @type {?} */
    SituationClockingEvent.prototype.id;
    /** @type {?} */
    SituationClockingEvent.prototype.situation;
    /** @type {?} */
    SituationClockingEvent.prototype.complementarySituation;
    /** @type {?} */
    SituationClockingEvent.prototype.exceptionSituation;
    /** @type {?} */
    SituationClockingEvent.prototype.mandatoryAdjustmentReason;
    /** @type {?} */
    SituationClockingEvent.prototype.daytimeSituation;
    /** @type {?} */
    SituationClockingEvent.prototype.convertNightHours;
    /** @type {?} */
    SituationClockingEvent.prototype.obligateAttachmentOnLeave;
    /** @type {?} */
    SituationClockingEvent.prototype.createdBy;
    /** @type {?} */
    SituationClockingEvent.prototype.createdDate;
    /** @type {?} */
    SituationClockingEvent.prototype.lastModifiedBy;
    /** @type {?} */
    SituationClockingEvent.prototype.lastModifiedDate;
    /** @type {?} */
    SituationClockingEvent.prototype.custom;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/time-evaluation-situation-definition-history/time-evaluation-situation-definition-history.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PACKAGE_IMPORTS:START}*/
/** @type {?} */
var moment$a = moment_;
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
var  /*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
TimeEvaluationSituationDefinitionHistory = /** @class */ (function () {
    function TimeEvaluationSituationDefinitionHistory() {
    }
    /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/
    /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/
    /**
     * @param {?} timeEvaluationSituationDefinitionHistoryDto
     * @param {?=} originEntity
     * @return {?}
     */
    TimeEvaluationSituationDefinitionHistory.fromDto = /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/
    /**
     * @param {?} timeEvaluationSituationDefinitionHistoryDto
     * @param {?=} originEntity
     * @return {?}
     */
    function (timeEvaluationSituationDefinitionHistoryDto, originEntity) {
        /** @type {?} */
        var model = __assign({}, timeEvaluationSituationDefinitionHistoryDto);
        model.startDate = model.startDate && moment$a(model.startDate).toDate();
        model.endDate = model.endDate && moment$a(model.endDate).toDate();
        model.createdDate = model.createdDate && moment$a(model.createdDate).toDate();
        model.lastModifiedDate = model.lastModifiedDate && moment$a(model.lastModifiedDate).toDate();
        if (model.normalOvertimeSeparationLimit && model.normalOvertimeSeparationLimit !== undefined) {
            model.normalOvertimeSeparationLimit = convertMinutesToTime(model.normalOvertimeSeparationLimit.toString());
        }
        if (model.overtimeSeparationLimitDuringRest && model.normalOvertimeSeparationLimit !== undefined) {
            model.overtimeSeparationLimitDuringRest = convertMinutesToTime(model.overtimeSeparationLimitDuringRest.toString());
        }
        if (model.overtimeSeparationLimitDuringCompensatedDays && model.overtimeSeparationLimitDuringCompensatedDays !== undefined) {
            model.overtimeSeparationLimitDuringCompensatedDays = convertMinutesToTime(model.overtimeSeparationLimitDuringCompensatedDays.toString());
        }
        if (model.overtimeSeparationLimitDuringHoliday && model.overtimeSeparationLimitDuringHoliday !== undefined) {
            model.overtimeSeparationLimitDuringHoliday = convertMinutesToTime(model.overtimeSeparationLimitDuringHoliday.toString());
        }
        if (model.overtimeSeparationLimitDuringDayOff && model.overtimeSeparationLimitDuringDayOff !== undefined) {
            model.overtimeSeparationLimitDuringDayOff = convertMinutesToTime(model.overtimeSeparationLimitDuringDayOff.toString());
        }
        /** @type {?} */
        var lookupSeparator = " - ";
        /** @type {?} */
        var displayFields = ["situationDefinition.code", "situationDefinition.name", "startDate", "endDate"];
        model.label = displayFields.map((/**
         * @param {?} field
         * @return {?}
         */
        function (field) { return model[field]; })).join(lookupSeparator);
        if (originEntity !== "TimeEvaluationSituationDefinition" && model.situationDefinition)
            model.situationDefinition = TimeEvaluationSituationDefinition.fromDto(model.situationDefinition, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.workSituation)
            model.workSituation = SituationClockingEvent.fromDto(model.workSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.nightShiftWorkPremium)
            model.nightShiftWorkPremium = SituationClockingEvent.fromDto(model.nightShiftWorkPremium, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.invalidEventsSituation)
            model.invalidEventsSituation = SituationClockingEvent.fromDto(model.invalidEventsSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.vacationPaidLeaveSituation)
            model.vacationPaidLeaveSituation = SituationClockingEvent.fromDto(model.vacationPaidLeaveSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.dailyRestViolationSituation)
            model.dailyRestViolationSituation = SituationClockingEvent.fromDto(model.dailyRestViolationSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.workBreakViolationSituation)
            model.workBreakViolationSituation = SituationClockingEvent.fromDto(model.workBreakViolationSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.absenceSituation)
            model.absenceSituation = SituationClockingEvent.fromDto(model.absenceSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.tardinessSituation)
            model.tardinessSituation = SituationClockingEvent.fromDto(model.tardinessSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.intermediateLeaveSituation)
            model.intermediateLeaveSituation = SituationClockingEvent.fromDto(model.intermediateLeaveSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.earlyLeaveSituation)
            model.earlyLeaveSituation = SituationClockingEvent.fromDto(model.earlyLeaveSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.absenceSituationOnRelayScheduleHolidays)
            model.absenceSituationOnRelayScheduleHolidays = SituationClockingEvent.fromDto(model.absenceSituationOnRelayScheduleHolidays, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.unauthorizedOvertime)
            model.unauthorizedOvertime = SituationClockingEvent.fromDto(model.unauthorizedOvertime, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeBefore)
            model.overtimeBefore = SituationClockingEvent.fromDto(model.overtimeBefore, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeEntry)
            model.overtimeEntry = SituationClockingEvent.fromDto(model.overtimeEntry, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeDuringMeal)
            model.overtimeDuringMeal = SituationClockingEvent.fromDto(model.overtimeDuringMeal, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.leaveOvertime)
            model.leaveOvertime = SituationClockingEvent.fromDto(model.leaveOvertime, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeAfter)
            model.overtimeAfter = SituationClockingEvent.fromDto(model.overtimeAfter, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeDuringRest)
            model.overtimeDuringRest = SituationClockingEvent.fromDto(model.overtimeDuringRest, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeOnCompensatedDays)
            model.overtimeOnCompensatedDays = SituationClockingEvent.fromDto(model.overtimeOnCompensatedDays, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeDuringHoliday)
            model.overtimeDuringHoliday = SituationClockingEvent.fromDto(model.overtimeDuringHoliday, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeDuringDayOff)
            model.overtimeDuringDayOff = SituationClockingEvent.fromDto(model.overtimeDuringDayOff, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeSituationOnRelayScheduleHolidays)
            model.overtimeSituationOnRelayScheduleHolidays = SituationClockingEvent.fromDto(model.overtimeSituationOnRelayScheduleHolidays, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.nightShiftOvertimePremiumSituation)
            model.nightShiftOvertimePremiumSituation = SituationClockingEvent.fromDto(model.nightShiftOvertimePremiumSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeSeparationBefore)
            model.overtimeSeparationBefore = SituationClockingEvent.fromDto(model.overtimeSeparationBefore, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeSeparationEntry)
            model.overtimeSeparationEntry = SituationClockingEvent.fromDto(model.overtimeSeparationEntry, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeSeparationDuringMeal)
            model.overtimeSeparationDuringMeal = SituationClockingEvent.fromDto(model.overtimeSeparationDuringMeal, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeSeparationLeave)
            model.overtimeSeparationLeave = SituationClockingEvent.fromDto(model.overtimeSeparationLeave, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeSeparationAfter)
            model.overtimeSeparationAfter = SituationClockingEvent.fromDto(model.overtimeSeparationAfter, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeSeparationDuringRest)
            model.overtimeSeparationDuringRest = SituationClockingEvent.fromDto(model.overtimeSeparationDuringRest, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeSeparationDuringCompensatedDays)
            model.overtimeSeparationDuringCompensatedDays = SituationClockingEvent.fromDto(model.overtimeSeparationDuringCompensatedDays, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeSeparationDuringHoliday)
            model.overtimeSeparationDuringHoliday = SituationClockingEvent.fromDto(model.overtimeSeparationDuringHoliday, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeSeparationDuringDayOff)
            model.overtimeSeparationDuringDayOff = SituationClockingEvent.fromDto(model.overtimeSeparationDuringDayOff, "TimeEvaluationSituationDefinitionHistory");
        return (/** @type {?} */ (model));
    };
    /**
     * @param {?} timeEvaluationSituationDefinitionHistory
     * @param {?=} originEntity
     * @return {?}
     */
    TimeEvaluationSituationDefinitionHistory.toDto = /**
     * @param {?} timeEvaluationSituationDefinitionHistory
     * @param {?=} originEntity
     * @return {?}
     */
    function (timeEvaluationSituationDefinitionHistory, originEntity) {
        /** @type {?} */
        var dto = __assign({}, timeEvaluationSituationDefinitionHistory);
        if (dto.normalOvertimeSeparationLimit && dto.normalOvertimeSeparationLimit !== undefined) {
            dto.normalOvertimeSeparationLimit = convertTimeToMinutes(dto.normalOvertimeSeparationLimit);
        }
        if (dto.overtimeSeparationLimitDuringRest && dto.overtimeSeparationLimitDuringRest !== undefined) {
            dto.overtimeSeparationLimitDuringRest = convertTimeToMinutes(dto.overtimeSeparationLimitDuringRest);
        }
        if (dto.overtimeSeparationLimitDuringCompensatedDays && dto.overtimeSeparationLimitDuringCompensatedDays !== undefined) {
            dto.overtimeSeparationLimitDuringCompensatedDays = convertTimeToMinutes(dto.overtimeSeparationLimitDuringCompensatedDays);
        }
        if (dto.overtimeSeparationLimitDuringHoliday && dto.overtimeSeparationLimitDuringHoliday !== undefined) {
            dto.overtimeSeparationLimitDuringHoliday = convertTimeToMinutes(dto.overtimeSeparationLimitDuringHoliday);
        }
        if (dto.overtimeSeparationLimitDuringDayOff && dto.overtimeSeparationLimitDuringDayOff !== undefined) {
            dto.overtimeSeparationLimitDuringDayOff = convertTimeToMinutes(dto.overtimeSeparationLimitDuringDayOff);
        }
        dto.startDate = dto.startDate && moment$a(dto.startDate).format("YYYY-MM-DD");
        dto.endDate = dto.endDate && moment$a(dto.endDate).format("YYYY-MM-DD");
        dto.createdDate = dto.createdDate && moment$a(dto.createdDate).format();
        dto.lastModifiedDate = dto.lastModifiedDate && moment$a(dto.lastModifiedDate).format();
        delete dto.label;
        if (originEntity !== "TimeEvaluationSituationDefinition" && dto.situationDefinition)
            dto.situationDefinition = TimeEvaluationSituationDefinition.toDto(dto.situationDefinition, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.workSituation)
            dto.workSituation = SituationClockingEvent.toDto(dto.workSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.nightShiftWorkPremium)
            dto.nightShiftWorkPremium = SituationClockingEvent.toDto(dto.nightShiftWorkPremium, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.invalidEventsSituation)
            dto.invalidEventsSituation = SituationClockingEvent.toDto(dto.invalidEventsSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.vacationPaidLeaveSituation)
            dto.vacationPaidLeaveSituation = SituationClockingEvent.toDto(dto.vacationPaidLeaveSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.dailyRestViolationSituation)
            dto.dailyRestViolationSituation = SituationClockingEvent.toDto(dto.dailyRestViolationSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.workBreakViolationSituation)
            dto.workBreakViolationSituation = SituationClockingEvent.toDto(dto.workBreakViolationSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.absenceSituation)
            dto.absenceSituation = SituationClockingEvent.toDto(dto.absenceSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.tardinessSituation)
            dto.tardinessSituation = SituationClockingEvent.toDto(dto.tardinessSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.intermediateLeaveSituation)
            dto.intermediateLeaveSituation = SituationClockingEvent.toDto(dto.intermediateLeaveSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.earlyLeaveSituation)
            dto.earlyLeaveSituation = SituationClockingEvent.toDto(dto.earlyLeaveSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.absenceSituationOnRelayScheduleHolidays)
            dto.absenceSituationOnRelayScheduleHolidays = SituationClockingEvent.toDto(dto.absenceSituationOnRelayScheduleHolidays, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.unauthorizedOvertime)
            dto.unauthorizedOvertime = SituationClockingEvent.toDto(dto.unauthorizedOvertime, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeBefore)
            dto.overtimeBefore = SituationClockingEvent.toDto(dto.overtimeBefore, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeEntry)
            dto.overtimeEntry = SituationClockingEvent.toDto(dto.overtimeEntry, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeDuringMeal)
            dto.overtimeDuringMeal = SituationClockingEvent.toDto(dto.overtimeDuringMeal, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.leaveOvertime)
            dto.leaveOvertime = SituationClockingEvent.toDto(dto.leaveOvertime, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeAfter)
            dto.overtimeAfter = SituationClockingEvent.toDto(dto.overtimeAfter, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeDuringRest)
            dto.overtimeDuringRest = SituationClockingEvent.toDto(dto.overtimeDuringRest, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeOnCompensatedDays)
            dto.overtimeOnCompensatedDays = SituationClockingEvent.toDto(dto.overtimeOnCompensatedDays, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeDuringHoliday)
            dto.overtimeDuringHoliday = SituationClockingEvent.toDto(dto.overtimeDuringHoliday, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeDuringDayOff)
            dto.overtimeDuringDayOff = SituationClockingEvent.toDto(dto.overtimeDuringDayOff, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeSituationOnRelayScheduleHolidays)
            dto.overtimeSituationOnRelayScheduleHolidays = SituationClockingEvent.toDto(dto.overtimeSituationOnRelayScheduleHolidays, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.nightShiftOvertimePremiumSituation)
            dto.nightShiftOvertimePremiumSituation = SituationClockingEvent.toDto(dto.nightShiftOvertimePremiumSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeSeparationBefore)
            dto.overtimeSeparationBefore = SituationClockingEvent.toDto(dto.overtimeSeparationBefore, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeSeparationEntry)
            dto.overtimeSeparationEntry = SituationClockingEvent.toDto(dto.overtimeSeparationEntry, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeSeparationDuringMeal)
            dto.overtimeSeparationDuringMeal = SituationClockingEvent.toDto(dto.overtimeSeparationDuringMeal, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeSeparationLeave)
            dto.overtimeSeparationLeave = SituationClockingEvent.toDto(dto.overtimeSeparationLeave, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeSeparationAfter)
            dto.overtimeSeparationAfter = SituationClockingEvent.toDto(dto.overtimeSeparationAfter, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeSeparationDuringRest)
            dto.overtimeSeparationDuringRest = SituationClockingEvent.toDto(dto.overtimeSeparationDuringRest, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeSeparationDuringCompensatedDays)
            dto.overtimeSeparationDuringCompensatedDays = SituationClockingEvent.toDto(dto.overtimeSeparationDuringCompensatedDays, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeSeparationDuringHoliday)
            dto.overtimeSeparationDuringHoliday = SituationClockingEvent.toDto(dto.overtimeSeparationDuringHoliday, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeSeparationDuringDayOff)
            dto.overtimeSeparationDuringDayOff = SituationClockingEvent.toDto(dto.overtimeSeparationDuringDayOff, "TimeEvaluationSituationDefinitionHistory");
        return dto;
    };
    return TimeEvaluationSituationDefinitionHistory;
}());
if (false) {
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.id;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.situationDefinition;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.startDate;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.endDate;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.workSituation;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.nightShiftWorkPremium;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.invalidEventsSituation;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.vacationPaidLeaveSituation;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.dailyRestViolationSituation;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.workBreakViolationSituation;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.absenceSituation;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.tardinessSituation;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.intermediateLeaveSituation;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.earlyLeaveSituation;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.absenceSituationOnRelayScheduleHolidays;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.percentageNextDay;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.normalOvertimeSeparationLimit;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.separateOvertimeAfterConvertingNightShiftHours;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.unauthorizedOvertime;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeBefore;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeEntry;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeDuringMeal;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.leaveOvertime;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeAfter;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeSeparationLimitDuringRest;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeDuringRest;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeSeparationLimitDuringCompensatedDays;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeOnCompensatedDays;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeSeparationLimitDuringHoliday;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeDuringHoliday;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeSeparationLimitDuringDayOff;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeDuringDayOff;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeSituationOnRelayScheduleHolidays;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.nightShiftOvertimePremiumSituation;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeSeparationBefore;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeSeparationEntry;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeSeparationDuringMeal;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeSeparationLeave;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeSeparationAfter;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeSeparationDuringRest;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeSeparationDuringCompensatedDays;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeSeparationDuringHoliday;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.overtimeSeparationDuringDayOff;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.createdBy;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.createdDate;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.lastModifiedBy;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.lastModifiedDate;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistory.prototype.custom;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/time-evaluation-situation-definition-history/time-evaluation-situation-definition-history-dto.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PACKAGE_IMPORTS:START}*/
/*{CA:PACKAGE_IMPORTS:END}*/
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
/**
 * @record
 */
function TimeEvaluationSituationDefinitionHistoryDto() { }
if (false) {
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.id;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.situationDefinition;
    /** @type {?} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.startDate;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.endDate;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.workSituation;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.nightShiftWorkPremium;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.invalidEventsSituation;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.vacationPaidLeaveSituation;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.dailyRestViolationSituation;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.workBreakViolationSituation;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.absenceSituation;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.tardinessSituation;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.intermediateLeaveSituation;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.earlyLeaveSituation;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.absenceSituationOnRelayScheduleHolidays;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.percentageNextDay;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.normalOvertimeSeparationLimit;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.separateOvertimeAfterConvertingNightShiftHours;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.unauthorizedOvertime;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeBefore;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeEntry;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeDuringMeal;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.leaveOvertime;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeAfter;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeSeparationLimitDuringRest;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeDuringRest;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeSeparationLimitDuringCompensatedDays;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeOnCompensatedDays;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeSeparationLimitDuringHoliday;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeDuringHoliday;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeSeparationLimitDuringDayOff;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeDuringDayOff;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeSituationOnRelayScheduleHolidays;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.nightShiftOvertimePremiumSituation;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeSeparationBefore;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeSeparationEntry;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeSeparationDuringMeal;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeSeparationLeave;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeSeparationAfter;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeSeparationDuringRest;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeSeparationDuringCompensatedDays;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeSeparationDuringHoliday;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.overtimeSeparationDuringDayOff;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.createdBy;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.createdDate;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.lastModifiedBy;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.lastModifiedDate;
    /** @type {?|undefined} */
    TimeEvaluationSituationDefinitionHistoryDto.prototype.custom;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/time-evaluation-situation-definition-history/index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/situation-clocking-event/situation-clocking-event-dto.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/*{CA:PACKAGE_IMPORTS:START}*/
/*{CA:PACKAGE_IMPORTS:END}*/
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/
/**
 * @record
 */
function SituationClockingEventDto() { }
if (false) {
    /** @type {?|undefined} */
    SituationClockingEventDto.prototype.id;
    /** @type {?|undefined} */
    SituationClockingEventDto.prototype.situation;
    /** @type {?|undefined} */
    SituationClockingEventDto.prototype.complementarySituation;
    /** @type {?|undefined} */
    SituationClockingEventDto.prototype.exceptionSituation;
    /** @type {?|undefined} */
    SituationClockingEventDto.prototype.mandatoryAdjustmentReason;
    /** @type {?} */
    SituationClockingEventDto.prototype.daytimeSituation;
    /** @type {?|undefined} */
    SituationClockingEventDto.prototype.convertNightHours;
    /** @type {?|undefined} */
    SituationClockingEventDto.prototype.obligateAttachmentOnLeave;
    /** @type {?|undefined} */
    SituationClockingEventDto.prototype.createdBy;
    /** @type {?|undefined} */
    SituationClockingEventDto.prototype.createdDate;
    /** @type {?|undefined} */
    SituationClockingEventDto.prototype.lastModifiedBy;
    /** @type {?|undefined} */
    SituationClockingEventDto.prototype.lastModifiedDate;
    /** @type {?|undefined} */
    SituationClockingEventDto.prototype.custom;
}

/**
 * @fileoverview added by tsickle
 * Generated from: core/entities/situation-clocking-event/index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: core/enums/clocking-event-tolerance-type.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var ClockingEventToleranceType = {
    V1: "V1",
    V2: "V2",
};

/**
 * @fileoverview added by tsickle
 * Generated from: core/enums/consider-clocking-event-interval-type.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var ConsiderClockingEventIntervalType = {
    V1: "V1",
    V2: "V2",
    V3: "V3",
    V4: "V4",
};

/**
 * @fileoverview added by tsickle
 * Generated from: core/enums/retroactive-adjustment-type.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var RetroactiveAdjustmentType = {
    V1: "V1",
    V2: "V2",
};

/**
 * @fileoverview added by tsickle
 * Generated from: core/enums/verified-days-control-type.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var VerifiedDaysControlType = {
    V0: "V0",
    V1: "V1",
    V2: "V2",
};

/**
 * @fileoverview added by tsickle
 * Generated from: core/enums/index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: core/index.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: senior-gestao-pessoas-hcm-clocking-event-foundation-schedules-histories.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { Bridge, BridgeFormComponent, BridgeFormModule, BridgeService, ClockingEventToleranceType, CompanyClockingEventIndications, CompanyClockingEventIndicationsService, ConsiderClockingEventIntervalType, CoreSchedulesHistoriesModule, E001Pes, E001PesService, Employee, EmployeeService, FieldCustomizationService, FiltersStorageService, FocusService, PaginatorStorageService, RetroactiveAdjustmentType, Situation, SituationClockingEvent, SituationClockingEventService, SituationService, StorageService, TimeEvaluationDefinition, TimeEvaluationDefinitionService, TimeEvaluationSituationDefinition, TimeEvaluationSituationDefinitionHistory, TimeEvaluationSituationDefinitionHistoryService, TimeEvaluationSituationDefinitionService, VerifiedDaysControlType, convertMinutesToTime, convertTimeToMinutes, getTypeInformation, isValidFilter, mergeUnique, SharedScheduleModule as ɵa, BridgeModule as ɵb, EntityService as ɵc, EmployeeModule as ɵd, E001PesModule as ɵe, CompanyClockingEventIndicationsModule as ɵf, TimeEvaluationDefinitionModule as ɵg, SituationModule as ɵh, TimeEvaluationSituationDefinitionModule as ɵi, TimeEvaluationSituationDefinitionHistoryModule as ɵj, SituationClockingEventModule as ɵk };
//# sourceMappingURL=senior-gestao-pessoas-hcm-clocking-event-foundation-schedules-histories.js.map
